package com.ruoyi.psi.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import org.apache.ibatis.annotations.Param;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.psi.domain.ApprovalProcess;
import com.ruoyi.psi.service.IApprovalProcessService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 审批流程Controller
 * 
 * @author ruoyi
 * @date 2024-01-08
 */
@RestController
@RequestMapping("/psi/process")
public class ApprovalProcessController extends BaseController
{
    @Autowired
    private IApprovalProcessService approvalProcessService;

    /**
     * 查询审批流程列表
     */
    // @PreAuthorize("@ss.hasPermi('psi:process:list')")
    // @GetMapping("/list")
    // public TableDataInfo list(ApprovalProcess approvalProcess)
    // {
    //     startPage();
    //     List<ApprovalProcess> list = approvalProcessService.selectApprovalProcessList(approvalProcess);
    //     return getDataTable(list);
    // }

    /**
     * 导出审批流程列表
     */
    // @PreAuthorize("@ss.hasPermi('psi:process:export')")
    // @Log(title = "审批流程", businessType = BusinessType.EXPORT)
    // @PostMapping("/export")
    // public void export(HttpServletResponse response, ApprovalProcess approvalProcess)
    // {
    //     List<ApprovalProcess> list = approvalProcessService.selectApprovalProcessList(approvalProcess);
    //     ExcelUtil<ApprovalProcess> util = new ExcelUtil<ApprovalProcess>(ApprovalProcess.class);
    //     util.exportExcel(response, list, "审批流程数据");
    // }

    /**
     * 获取审批流程详细信息
     */
    @PreAuthorize("@ss.hasPermi('psi:process:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Integer id, @Param("excTenantId") Long excTenantId)
    {
        Long tenantId = this.getTenantId();
        if(null != excTenantId){
            tenantId = excTenantId;
        }
        ApprovalProcess approvalProcess = new ApprovalProcess();
        approvalProcess.setDocumentType(id);
        approvalProcess.setTenantId(tenantId);
        return success(approvalProcessService.selectApprovalProcessById(approvalProcess));
    }

    /**
     * 新增审批流程
     */
    // @PreAuthorize("@ss.hasPermi('psi:process:add')")
    // @Log(title = "审批流程", businessType = BusinessType.INSERT)
    // @PostMapping
    // public AjaxResult add(@RequestBody ApprovalProcess approvalProcess)
    // {
    //     Long tenantId = this.getTenantId();
    //     approvalProcess.setTenantId(tenantId);
    //     return toAjax(approvalProcessService.insertApprovalProcess(approvalProcess));
    // }

    /**
     * 修改审批流程
     */
    // @PreAuthorize("@ss.hasPermi('psi:process:edit')")
    @Log(title = "审批流程", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody List<ApprovalProcess> approvalProcessList)
    {
        Long tenantId = this.getTenantId();
        return toAjax(approvalProcessService.updateApprovalProcess(approvalProcessList,tenantId));
    }

    /**
     * 删除审批流程
     */
    // @PreAuthorize("@ss.hasPermi('psi:process:remove')")
    // @Log(title = "审批流程", businessType = BusinessType.DELETE)
	// @DeleteMapping("/{ids}")
    // public AjaxResult remove(@PathVariable Long[] ids)
    // {
    //     return toAjax(approvalProcessService.deleteApprovalProcessByIds(ids));
    // }

}
