package com.ruoyi.psi.controller;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class GoodsTest {
    public static void main(String[] args) {
        List<Goods> goodsList = new ArrayList<>();
        // 假设商品列表已经填充完整，每行包含商品id(goods_id)，数量(quantity)，单价(price_input)
        // 向商品列表 goodsList 添加商品信息
        goodsList.add(new Goods("1", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("2", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("3", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("4", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("5", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("6", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("7", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("8", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("9", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("10", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("11", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("12", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("13", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("14", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("15", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("16", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("17", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("18", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("19", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("20", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("21", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("22", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("23", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("24", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("25", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("26", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("27", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("28", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("29", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("30", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("31", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("32", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("33", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("34", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("35", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("36", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("37", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("38", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("39", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("40", new BigDecimal("15"), new BigDecimal("85")));

        BigDecimal ttt = BigDecimal.ZERO;
        for (Goods goods : goodsList) {
            BigDecimal lineAmount = goods.getQuantity().multiply(goods.getPrice());
            ttt = ttt.add(lineAmount);
        }
        System.out.println("总金额：" + ttt);

        BigDecimal totalAmount = new BigDecimal("8000");

        // 使用回溯算法，当商品数量和金额较大时，时间复杂度太高，建议使用贪心算法，找到近似解
        List<List<Goods>> selectedGoodsCombinations = findGoodsCombinations(goodsList, totalAmount);
        if (!selectedGoodsCombinations.isEmpty()) {
            // 找到符合条件的商品组合，输出商品信息
            System.out.println("满足条件的商品列表：");
            for (List<Goods> selectedGoods : selectedGoodsCombinations) {
                for (Goods goods : selectedGoods) {
                    System.out.println(goods);
                }
                System.out.println("------------");
            }
        } else {
            System.out.println("无法找到满足条件的商品列表。");
        }
    }

    private static List<List<Goods>> findGoodsCombinations(List<Goods> goodsList, BigDecimal totalAmount) {
        List<List<Goods>> selectedGoodsCombinations = new ArrayList<>();

        findCombinations(goodsList, totalAmount, 0, new ArrayList<>(), selectedGoodsCombinations);
        return selectedGoodsCombinations;
    }

    private static void findCombinations(List<Goods> goodsList, BigDecimal remainingAmount,
                                         int startIdx, List<Goods> selectedGoods,
                                         List<List<Goods>> selectedGoodsCombinations) {
        if (remainingAmount.compareTo(BigDecimal.ZERO) == 0) {
            // 找到一组满足条件的商品组合
            selectedGoodsCombinations.add(new ArrayList<>(selectedGoods));
            return;
        }

        if (remainingAmount.compareTo(BigDecimal.ZERO) < 0 || startIdx >= goodsList.size()) {
            // 当剩余金额小于0或者超出商品列表范围时，返回
            return;
        }

        for (int i = startIdx; i < goodsList.size(); i++) {
            Goods currentGoods = goodsList.get(i);
            BigDecimal currentAmount = currentGoods.getQuantity().multiply(currentGoods.getPrice());
            if (currentAmount.compareTo(remainingAmount) <= 0) {
                // 将当前商品添加到选中列表中
                selectedGoods.add(currentGoods);
                findCombinations(goodsList, remainingAmount.subtract(currentAmount), i + 1, selectedGoods, selectedGoodsCombinations);
                if(!selectedGoodsCombinations.isEmpty()){
                    return;
                }
                // 回溯，移除上一步添加的商品
                selectedGoods.remove(selectedGoods.size() - 1);
            }
        }
    }

    private static class Goods {
        private String id;
        private BigDecimal quantity;
        private BigDecimal price;

        public Goods(String id, BigDecimal quantity, BigDecimal price) {
            this.id = id;
            this.quantity = quantity;
            this.price = price;
        }

        public String getId() {
            return id;
        }

        public BigDecimal getQuantity() {
            return quantity;
        }

        public BigDecimal getPrice() {
            return price;
        }

        @Override
        public String toString() {
            return "商品ID: " + id + ", 数量: " + quantity + ", 单价: " + price;
        }
    }
}