package com.ruoyi.psi.controller;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

class Goods {
    private String id;
    private BigDecimal quantity;
    private BigDecimal price;

    public Goods(String id, BigDecimal quantity, BigDecimal price) {
        this.id = id;
        this.quantity = quantity;
        this.price = price;
    }

    public String getId() {
        return id;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    public BigDecimal getPrice() {
        return price;
    }

    @Override
    public String toString() {
        return "商品ID: " + id + ", 数量: " + quantity + ", 单价: " + price;
    }
}

public class GoodsTest2 {
    public static List<Goods> selectGoods(BigDecimal totalAmount, List<Goods> goodsList) {
        // 按照价格降序排序
        Collections.sort(goodsList, new Comparator<Goods>() {
            @Override
            public int compare(Goods o1, Goods o2) {
                return o2.getPrice().compareTo(o1.getPrice());
            }
        });

        List<Goods> selectedGoods = new ArrayList<>();
        BigDecimal remainingAmount = totalAmount;

        for (Goods goods : goodsList) {
            BigDecimal goodsAmount = goods.getQuantity().multiply(goods.getPrice()); // 计算商品金额

            if (goodsAmount.compareTo(remainingAmount) <= 0) {
                selectedGoods.add(goods);
                remainingAmount = remainingAmount.subtract(goodsAmount);
            }
        }

        return selectedGoods;
    }

    public static void main(String[] args) {

        List<Goods> goodsList = new ArrayList<>();
        goodsList.add(new Goods("1", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("2", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("3", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("4", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("5", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("6", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("7", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("8", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("9", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("10", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("11", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("12", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("13", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("14", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("15", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("16", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("17", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("18", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("19", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("20", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("21", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("22", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("23", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("24", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("25", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("26", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("27", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("28", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("29", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("30", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("31", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("32", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("33", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("34", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("35", new BigDecimal("15"), new BigDecimal("85")));
        goodsList.add(new Goods("36", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("37", new BigDecimal("5"), new BigDecimal("2.5")));
        goodsList.add(new Goods("38", new BigDecimal("60"), new BigDecimal("1.5")));
        goodsList.add(new Goods("39", new BigDecimal("20"), new BigDecimal("3.5")));
        goodsList.add(new Goods("40", new BigDecimal("15"), new BigDecimal("85")));

        BigDecimal ttt = BigDecimal.ZERO;
        for (Goods goods : goodsList) {
            BigDecimal lineAmount = goods.getQuantity().multiply(goods.getPrice());
            ttt = ttt.add(lineAmount);
        }
        System.out.println("总金额：" + ttt);

        BigDecimal totalAmount = new BigDecimal("1000");

        // 使用贪心算法找到近似解
        List<Goods> selectedGoods = selectGoods(totalAmount, goodsList);

        System.out.println("Selected Goods:");
        BigDecimal sAmount = BigDecimal.ZERO;
        for (Goods goods : selectedGoods) {
            System.out.println("Goods ID: " + goods.getId() + ", Quantity: " + goods.getQuantity() + ", Price: " + goods.getPrice());
            BigDecimal lineAmount = goods.getQuantity().multiply(goods.getPrice());
            sAmount = sAmount.add(lineAmount);
        }
        System.out.println("选中商品总金额：" + sAmount);
    }
}
