package com.ruoyi.psi.controller;

import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class GoodsTest3 {
    public static void main(String[] args) {
        List<Item> itemList = new ArrayList<>();
        itemList.add(new Item("1", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("2", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("3", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("4", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("5", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("6", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("7", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("8", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("9", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("10", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("11", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("12", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("13", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("14", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("15", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("16", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("17", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("18", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("19", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("20", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("21", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("22", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("23", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("24", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("25", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("26", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("27", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("28", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("29", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("30", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("31", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("32", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("33", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("34", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("35", new BigDecimal("15"), new BigDecimal("85")));
        itemList.add(new Item("36", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("37", new BigDecimal("5"), new BigDecimal("2.5")));
        itemList.add(new Item("38", new BigDecimal("60"), new BigDecimal("1.5")));
        itemList.add(new Item("39", new BigDecimal("20"), new BigDecimal("3.5")));
        itemList.add(new Item("40", new BigDecimal("15"), new BigDecimal("85")));

        // 指定金额
        BigDecimal targetAmount = new BigDecimal("2000");

        // 总金额
        BigDecimal totalAmount = BigDecimal.ZERO;
        for (Item item : itemList) {
            BigDecimal itemAmount = item.getPrice().multiply(item.getQuantity());
            totalAmount = totalAmount.add(itemAmount);
        }
        System.out.println("总金额：" + totalAmount);

        List<Item> selectedItems = null;
        BigDecimal sAmount = BigDecimal.ZERO;
        // 先正向扫一遍，看下是否有符合指定金额的数据
        selectedItems = getSelectedItems(false, itemList, targetAmount);
        for (Item item : selectedItems) {
            BigDecimal lineAmount = item.getQuantity().multiply(item.getPrice());
            sAmount = sAmount.add(lineAmount);
        }
        // 没有找到，再按比例减少数量
        if(sAmount.compareTo(targetAmount) != 0){
            // 比例
            int quantityMultiplier = totalAmount.divide(targetAmount, 0, RoundingMode.DOWN).intValue();
            if(quantityMultiplier == 1){
                selectedItems = getSelectedItems(true, itemList, targetAmount);
            } else {
                selectedItems = calculateSelectedItems(itemList, targetAmount, quantityMultiplier);
            }
        }

        sAmount = BigDecimal.ZERO;
        for (Item item : selectedItems) {
            System.out.println(item);
            BigDecimal lineAmount = item.getQuantity().multiply(item.getPrice());
            sAmount = sAmount.add(lineAmount);
        }
        System.out.println("选中商品总金额：" + sAmount);
    }

    public static List<Item> getSelectedItems(boolean isNeedSort, List<Item> itemList, BigDecimal targetAmount){
        if(isNeedSort){
            // 按照价格降序排序
            Collections.sort(itemList, new Comparator<Item>() {
                @Override
                public int compare(Item o1, Item o2) {
                    return o2.getPrice().compareTo(o1.getPrice());
                }
            });
        }

        List<Item> selectedGoods = new ArrayList<>();
        BigDecimal remainingAmount = targetAmount;

        for (Item item : itemList) {
            BigDecimal goodsAmount = item.getQuantity().multiply(item.getPrice()); // 计算商品金额

            if (goodsAmount.compareTo(remainingAmount) <= 0) {
                selectedGoods.add(item);
                remainingAmount = remainingAmount.subtract(goodsAmount);
            }
        }

        return selectedGoods;
    }
    public static List<Item> calculateSelectedItems(List<Item> itemList, BigDecimal targetAmount, int quantityMultiplier) {
        BigDecimal adjustedTotalAmount = targetAmount.multiply(new BigDecimal(quantityMultiplier));

        List<Item> selectedItems = new ArrayList<>();
        for (Item item : itemList) {
            BigDecimal itemAmount = item.getPrice().add(adjustedTotalAmount);
            BigDecimal originalQuantity = item.getQuantity();

            BigDecimal adjustedQuantity = originalQuantity.divide(new BigDecimal(quantityMultiplier), 0, RoundingMode.DOWN);
//            if(adjustedQuantity.compareTo(BigDecimal.ZERO) == 0){
//                adjustedQuantity = BigDecimal.ONE;
//            }
            item.setQuantity(adjustedQuantity);

            while (itemAmount.compareTo(targetAmount) <= 0 && item.getQuantity().compareTo(originalQuantity) <= 0) {
                item.setQuantity(item.getQuantity().add(BigDecimal.ONE));
                itemAmount = item.getPrice().multiply(item.getQuantity()).add(adjustedTotalAmount);
            }

            if (item.getQuantity().compareTo(originalQuantity) > 0) {
                item.setQuantity(originalQuantity);
            }

            if(item.getQuantity().compareTo(BigDecimal.ZERO) != 0){
                selectedItems.add(item);
            }
//            selectedItems.add(item);
        }

        return selectedItems;
    }

    public static class Item {
        private String itemId;
        private BigDecimal quantity;
        private BigDecimal price;

        public Item(String itemId, BigDecimal quantity, BigDecimal price) {
            this.itemId = itemId;
            this.quantity = quantity;
            this.price = price;
        }

        public String getItemId() {
            return itemId;
        }

        public BigDecimal getQuantity() {
            return quantity;
        }

        public void setQuantity(BigDecimal quantity) {
            this.quantity = quantity;
        }

        public BigDecimal getPrice() {
            return price;
        }

        @Override
        public String toString() {
            return "Item{" +
                    "itemId='" + itemId + '\'' +
                    ", quantity=" + quantity +
                    ", price=" + price +
                    '}';
        }
    }
}