package com.ruoyi.psi.controller;

import com.ruoyi.psi.domain.PsiGoods;

import java.util.*;

public class Test {
    public static void main(String[] args)
    {
        // 遍历采购明细表，根据商品名称+规格+租户id，获取这个商品的列表，即可以供货的供应商及商品ID，并塞到class_score二维数组中

        // 这里只是模拟，创建了很多PsiGoods对象
        // 商品1有2个供应商可以供货
        PsiGoods good1_sup1 = new PsiGoods();
        good1_sup1.setId(100l);
        good1_sup1.setSupplierId(1l);
        PsiGoods good1_sup2 = new PsiGoods();
        good1_sup2.setId(200l);
        good1_sup2.setSupplierId(2l);

        // 商品2有3个供应商可以供货
        PsiGoods good2_sup1 = new PsiGoods();
        good2_sup1.setId(200001L);
        good2_sup1.setSupplierId(1l);
        PsiGoods good2_sup2 = new PsiGoods();
        good2_sup2.setId(200002L);
        good2_sup2.setSupplierId(2l);
        PsiGoods good2_sup4 = new PsiGoods();
        good2_sup4.setId(200004L);
        good2_sup4.setSupplierId(4l);

        // 商品2有3个供应商可以供货
        PsiGoods good3_sup1 = new PsiGoods();
        good3_sup1.setId(300001L);
        good3_sup1.setSupplierId(1l);
        PsiGoods good3_sup2 = new PsiGoods();
        good3_sup2.setId(300002L);
        good3_sup2.setSupplierId(2l);
        PsiGoods good3_sup4 = new PsiGoods();
        good3_sup4.setId(300004L);
        good3_sup4.setSupplierId(1l);

        PsiGoods[][] class_score={{good1_sup2, good1_sup1},{good2_sup1,good2_sup2,good2_sup4},{good3_sup1,good3_sup4,good3_sup2}};

        // 获取供应商交集
        // 首先创建一个HashSet来存储交集元素,将第一个数组class_score[0]的元素添加到集合中
        Set<Long> intersection = new HashSet<>();
        for (int i = 0; i < class_score[0].length; i++) {
            intersection.add(class_score[0][i].getSupplierId());
        }
        // 然后，遍历剩余的数组，并使用retainAll方法计算交集，这个方法会保留集合中与当前数组元素相同的元素。
        for (int i = 1; i < class_score.length; i++) {
            Set<Long> currentSet = new HashSet<>();
            for (int j = 0; j < class_score[i].length; j++) {
                currentSet.add(class_score[i][j].getSupplierId());
            }
            intersection.retainAll(currentSet);
        }
        System.out.println(intersection);

        // 过滤掉不在交集范围的商品
        List<PsiGoods[]> filteredGoods = new ArrayList<>();

        for (int i = 0; i < class_score.length; i++) {
            List<PsiGoods> goodsList = new ArrayList<>();
            for (int j = 0; j < class_score[i].length; j++) {
                if (intersection.contains(class_score[i][j].getSupplierId())) {
                    goodsList.add(class_score[i][j]);
                }
            }
            if (!goodsList.isEmpty()) {
                filteredGoods.add(goodsList.toArray(new PsiGoods[0]));
            }
        }

        // 生成新的二维数组
        PsiGoods[][] newClassScore = filteredGoods.toArray(new PsiGoods[0][]);
        System.out.println(newClassScore);
        // 输出结果
        for (PsiGoods[] goods : newClassScore) {
            for (PsiGoods good : goods) {
                System.out.println("ID: " + good.getId() + ", SupplierID: " + good.getSupplierId());
            }
        }
    }
}
