package com.ruoyi.psi.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 审批流程对象 approval_process
 * 
 * @author ruoyi
 * @date 2024-01-08
 */
public class ApprovalProcess extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 单据类型:1供应商2商品3采购需求6入库7出库8入库汇总9出库汇总 */
    @Excel(name = "单据类型:1供应商2商品3采购需求6入库7出库8入库汇总9出库汇总10销货单")
    private Integer documentType;

    /** 审批阶段名称 */
    @Excel(name = "审批阶段名称")
    private String stageName;

    /** 默认审批人id */
    @Excel(name = "默认审批人id")
    private Long approvalUser;

    /** 默认审批人名称 */
    @Excel(name = "默认审批人名称")
    private String approvalUserName;

    /** 审批顺序号 */
    @Excel(name = "审批顺序号")
    private Integer approvalOrder;

    /** 是否结束0:未结束1:已结束 */
    @Excel(name = "是否结束0:未结束1:已结束")
    private Integer isEnd;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 该审核人租户id*/
    private Long zTenantId;

    /** 登陆账号*/
    private String userName;

    public ApprovalProcess() {
    }

    public ApprovalProcess(Long id, Integer documentType, String stageName, Long approvalUser, String approvalUserName, Integer approvalOrder, Integer isEnd, Long tenantId, Long zTenantId, String userName) {
        this.id = id;
        this.documentType = documentType;
        this.stageName = stageName;
        this.approvalUser = approvalUser;
        this.approvalUserName = approvalUserName;
        this.approvalOrder = approvalOrder;
        this.isEnd = isEnd;
        this.tenantId = tenantId;
        this.zTenantId = zTenantId;
        this.userName = userName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getDocumentType() {
        return documentType;
    }

    public void setDocumentType(Integer documentType) {
        this.documentType = documentType;
    }

    public String getStageName() {
        return stageName;
    }

    public void setStageName(String stageName) {
        this.stageName = stageName;
    }

    public Long getApprovalUser() {
        return approvalUser;
    }

    public void setApprovalUser(Long approvalUser) {
        this.approvalUser = approvalUser;
    }

    public String getApprovalUserName() {
        return approvalUserName;
    }

    public void setApprovalUserName(String approvalUserName) {
        this.approvalUserName = approvalUserName;
    }

    public Integer getApprovalOrder() {
        return approvalOrder;
    }

    public void setApprovalOrder(Integer approvalOrder) {
        this.approvalOrder = approvalOrder;
    }

    public Integer getIsEnd() {
        return isEnd;
    }

    public void setIsEnd(Integer isEnd) {
        this.isEnd = isEnd;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public Long getzTenantId() {
        return zTenantId;
    }

    public void setzTenantId(Long zTenantId) {
        this.zTenantId = zTenantId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }
}
