package com.ruoyi.psi.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 审批记录对象 approval_recording
 * 
 * @author ruoyi
 * @date 2024-01-19
 */
public class ApprovalRecording extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 单据类型:1供应商2商品3采购需求6入库7出库8入库汇总9出库汇总 */
    @Excel(name = "单据类型:1供应商2商品3采购需求6入库7出库8入库汇总9出库汇总10销货单")
    private Integer documentType;

    /** 单据id */
    @Excel(name = "单据id")
    private Long documentId;

    /** 审批阶段名称 */
    @Excel(name = "审批阶段名称")
    private String stageName;

    /** 审批顺序号 */
    @Excel(name = "审批顺序号")
    private Integer approvalOrder;

    /** 是否结束0:未结束1:已结束 */
    @Excel(name = "是否结束0:未结束1:已结束")
    private Integer isEnd;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 审核人id */
    @Excel(name = "审核人id")
    private Long approvalUser;

    /** 审核人姓名 */
    @Excel(name = "审核人姓名")
    private String approvalUserName;

    /** 提交人id */
    @Excel(name = "提交人id")
    private Long submitId;

    /** 提交人姓名 */
    @Excel(name = "提交人姓名")
    private String submitName;

    /** 提交时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "提交时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date submitTime;

    /** 审核时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "审核时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date approvarTime;

    /** 审核状态:0未审核、1已审核 */
    @Excel(name = "审核状态:0未审核、1已审核")
    private Integer approvarType;

    /** 审核意见:0通过 1不通过 */
    @Excel(name = "审核意见:0通过 1不通过")
    private Integer approvarOpinion;

    // 实际id
    private Long zTenantId;

    public ApprovalRecording() {
    }

    public ApprovalRecording(Long id, Integer documentType, Long documentId, String stageName, Integer approvalOrder, Integer isEnd, Long tenantId, Long approvalUser, String approvalUserName, Long submitId, String submitName, Date submitTime, Date approvarTime, Integer approvarType, Integer approvarOpinion, Long zTenantId) {
        this.id = id;
        this.documentType = documentType;
        this.documentId = documentId;
        this.stageName = stageName;
        this.approvalOrder = approvalOrder;
        this.isEnd = isEnd;
        this.tenantId = tenantId;
        this.approvalUser = approvalUser;
        this.approvalUserName = approvalUserName;
        this.submitId = submitId;
        this.submitName = submitName;
        this.submitTime = submitTime;
        this.approvarTime = approvarTime;
        this.approvarType = approvarType;
        this.approvarOpinion = approvarOpinion;
        this.zTenantId = zTenantId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Integer getDocumentType() {
        return documentType;
    }

    public void setDocumentType(Integer documentType) {
        this.documentType = documentType;
    }

    public Long getDocumentId() {
        return documentId;
    }

    public void setDocumentId(Long documentId) {
        this.documentId = documentId;
    }

    public String getStageName() {
        return stageName;
    }

    public void setStageName(String stageName) {
        this.stageName = stageName;
    }

    public Integer getApprovalOrder() {
        return approvalOrder;
    }

    public void setApprovalOrder(Integer approvalOrder) {
        this.approvalOrder = approvalOrder;
    }

    public Integer getIsEnd() {
        return isEnd;
    }

    public void setIsEnd(Integer isEnd) {
        this.isEnd = isEnd;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public Long getApprovalUser() {
        return approvalUser;
    }

    public void setApprovalUser(Long approvalUser) {
        this.approvalUser = approvalUser;
    }

    public String getApprovalUserName() {
        return approvalUserName;
    }

    public void setApprovalUserName(String approvalUserName) {
        this.approvalUserName = approvalUserName;
    }

    public Long getSubmitId() {
        return submitId;
    }

    public void setSubmitId(Long submitId) {
        this.submitId = submitId;
    }

    public String getSubmitName() {
        return submitName;
    }

    public void setSubmitName(String submitName) {
        this.submitName = submitName;
    }

    public Date getSubmitTime() {
        return submitTime;
    }

    public void setSubmitTime(Date submitTime) {
        this.submitTime = submitTime;
    }

    public Date getApprovarTime() {
        return approvarTime;
    }

    public void setApprovarTime(Date approvarTime) {
        this.approvarTime = approvarTime;
    }

    public Integer getApprovarType() {
        return approvarType;
    }

    public void setApprovarType(Integer approvarType) {
        this.approvarType = approvarType;
    }

    public Integer getApprovarOpinion() {
        return approvarOpinion;
    }

    public void setApprovarOpinion(Integer approvarOpinion) {
        this.approvarOpinion = approvarOpinion;
    }

    public Long getzTenantId() {
        return zTenantId;
    }

    public void setzTenantId(Long zTenantId) {
        this.zTenantId = zTenantId;
    }
}
