package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 竞价单对象 psi_bidding
 * 
 * @author ruoyi
 * @date 2023-12-17
 */
public class Bidding extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 创建人 */
    @Excel(name = "创建人")
    private Long createUser;

    /** 供应商id */
    @Excel(name = "供应商id")
    private Long supplierId;

    /** 采购单id */
    @Excel(name = "采购单id")
    private Long purchaseId;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 总金额 */
    @Excel(name = "总金额")
    private BigDecimal totalAmount;

    /** 状态 0未提交 1已提交*/
    private Integer status;

    private String createUsername;

    @Excel(name = "订货人姓名")
    private String tenantName;

    @Excel(name = "供应商名称")
    private String supplierName;


    public Bidding() {
    }

    public Bidding(Long id, Long createUser, Long supplierId, Long purchaseId, Long tenantId, BigDecimal totalAmount, Integer status, String createUsername, String tenantName, String supplierName) {
        this.id = id;
        this.createUser = createUser;
        this.supplierId = supplierId;
        this.purchaseId = purchaseId;
        this.tenantId = tenantId;
        this.totalAmount = totalAmount;
        this.status = status;
        this.createUsername = createUsername;
        this.tenantName = tenantName;
        this.supplierName = supplierName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Long getPurchaseId() {
        return purchaseId;
    }

    public void setPurchaseId(Long purchaseId) {
        this.purchaseId = purchaseId;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public BigDecimal getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(BigDecimal totalAmount) {
        this.totalAmount = totalAmount;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getCreateUsername() {
        return createUsername;
    }

    public void setCreateUsername(String createUsername) {
        this.createUsername = createUsername;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    @Override
    public String toString() {
        return "Bidding{" +
                "id=" + id +
                ", createUser=" + createUser +
                ", supplierId=" + supplierId +
                ", purchaseId=" + purchaseId +
                ", tenantId=" + tenantId +
                ", totalAmount=" + totalAmount +
                ", status=" + status +
                ", createUsername='" + createUsername + '\'' +
                ", tenantName='" + tenantName + '\'' +
                ", supplierName='" + supplierName + '\'' +
                '}';
    }
}
