package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 商品对象 psi_goods
 * 
 * @author ruoyi
 * @date 2023-12-12
 */
public class PsiGoods extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    @Excel(name = "商品编码")
    private Long id;

    /** 商品编码 */
    private String googsCode;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 规格 */
    @Excel(name = "规格")
    private String spec;

    /** 单位 */
    @Excel(name = "单位")
    private String unit;

    /** 单价 */
    @Excel(name = "单价",scale = 2)
    private BigDecimal price;

    /** 单价类型 0时价 1固定 */
    @Excel(name = "单价类型(时价、固定)",readConverterExp = "0=时价,1=固定")//0时价 1固定
    private Integer priceType;

    /** 生产厂家 */
    @Excel(name = "生产厂家")
    private String manufacturer;

    /** 供应商id */
    // @Excel(name = "供应商id")
    private Long supplierId;

    /** 供应商name */
    // @Excel(name = "供应商名称")
    private String supplierName;

    /** 状态 0：禁用 1启用 */
    // @Excel(name = "状态",readConverterExp = "0=禁用,1=启用")//0=禁用,1=启用
    private Integer status;

    /** 租户id */
    // @Excel(name = "租户id")
    private Long tenantId;

    /** 审批状态 0 未审核 1 已审核 2 审批中 */
    private Integer approvalType;

    /** 附件id */
    private Long annexId;

    public PsiGoods() {
    }

    public PsiGoods(Long id, String googsCode, String goodsName, String spec, String unit, BigDecimal price, Integer priceType, String manufacturer, Long supplierId, String supplierName, Integer status, Long tenantId, Integer approvalType, Long annexId) {
        this.id = id;
        this.googsCode = googsCode;
        this.goodsName = goodsName;
        this.spec = spec;
        this.unit = unit;
        this.price = price;
        this.priceType = priceType;
        this.manufacturer = manufacturer;
        this.supplierId = supplierId;
        this.supplierName = supplierName;
        this.status = status;
        this.tenantId = tenantId;
        this.approvalType = approvalType;
        this.annexId = annexId;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getGoogsCode() {
        return googsCode;
    }

    public void setGoogsCode(String googsCode) {
        this.googsCode = googsCode;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public Integer getPriceType() {
        return priceType;
    }

    public void setPriceType(Integer priceType) {
        this.priceType = priceType;
    }

    public String getManufacturer() {
        return manufacturer;
    }

    public void setManufacturer(String manufacturer) {
        this.manufacturer = manufacturer;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public Integer getApprovalType() {
        return approvalType;
    }

    public void setApprovalType(Integer approvalType) {
        this.approvalType = approvalType;
    }

    public Long getAnnexId() {
        return annexId;
    }

    public void setAnnexId(Long annexId) {
        this.annexId = annexId;
    }

    @Override
    public String toString() {
        return "PsiGoods{" +
                "id=" + id +
                ", googsCode='" + googsCode + '\'' +
                ", goodsName='" + goodsName + '\'' +
                ", spec='" + spec + '\'' +
                ", unit='" + unit + '\'' +
                ", price=" + price +
                ", priceType=" + priceType +
                ", manufacturer='" + manufacturer + '\'' +
                ", supplierId=" + supplierId +
                ", supplierName='" + supplierName + '\'' +
                ", status=" + status +
                ", tenantId=" + tenantId +
                ", approvalType=" + approvalType +
                ", annexId=" + annexId +
                '}';
    }
}
