package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 入库单对象 psi_storage
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public class PsiStorage extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 收货单id */
    @Excel(name = "收货单id")
    private Long supplyId;

    /** 供应商id */
    @Excel(name = "供应商id")
    private Long supplierId;

    /** 供应商名称 */
    @Excel(name = "供应商名称")
    private String supplierName;

    /** 入库人 */
    @Excel(name = "入库人")
    private Long createUser;

    /** 入库人姓名 */
    @Excel(name = "入库人姓名")
    private String createUserName;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 租户姓名 */
    @Excel(name = "租户姓名")
    private String tenantName;

    /** 本次入库金额 */
    @Excel(name = "本次入库金额")
    private BigDecimal amount;

    /** 审核 */
    @Excel(name = "审核")
    private Integer audit;

    /** 审核时间(出库时间) */
    private Date auditTime;

    /** 状态 0:未出库 1:已出库 2:出库审核中 3:出库审核完成*/
    private Integer status;

    /** 审核人*/
    private Long auditUser;

    /** 审核人姓名*/
    private String auditUserName;

    /** 备注*/
    private String remark;

    /** 业务日期*/
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date businessTime;

    /** 出库业务日期*/
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date businessOutTime;

    /** 仓库id */
    @Excel(name = "仓库id")
    private Long storeId;

    /** 仓库名称 */
    @Excel(name = "仓库名称")
    private String storeName;

    /** 销货单审核状态 1:已审核 0:未审核 2:审核中 */
    private Integer salesAuditStatus;

    public PsiStorage() {
    }

    public PsiStorage(Long id, Long supplyId, Long supplierId, String supplierName, Long createUser, String createUserName, Long tenantId, String tenantName, BigDecimal amount, Integer audit, Date auditTime, Integer status, Long auditUser, String auditUserName, String remark, Date businessTime, Date businessOutTime, Long storeId, String storeName, Integer salesAuditStatus) {
        this.id = id;
        this.supplyId = supplyId;
        this.supplierId = supplierId;
        this.supplierName = supplierName;
        this.createUser = createUser;
        this.createUserName = createUserName;
        this.tenantId = tenantId;
        this.tenantName = tenantName;
        this.amount = amount;
        this.audit = audit;
        this.auditTime = auditTime;
        this.status = status;
        this.auditUser = auditUser;
        this.auditUserName = auditUserName;
        this.remark = remark;
        this.businessTime = businessTime;
        this.businessOutTime = businessOutTime;
        this.storeId = storeId;
        this.storeName = storeName;
        this.salesAuditStatus = salesAuditStatus;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSupplyId() {
        return supplyId;
    }

    public void setSupplyId(Long supplyId) {
        this.supplyId = supplyId;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public Integer getAudit() {
        return audit;
    }

    public void setAudit(Integer audit) {
        this.audit = audit;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Long getAuditUser() {
        return auditUser;
    }

    public void setAuditUser(Long auditUser) {
        this.auditUser = auditUser;
    }

    public String getAuditUserName() {
        return auditUserName;
    }

    public void setAuditUserName(String auditUserName) {
        this.auditUserName = auditUserName;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Date getBusinessTime() {
        return businessTime;
    }

    public void setBusinessTime(Date businessTime) {
        this.businessTime = businessTime;
    }

    public Date getBusinessOutTime() {
        return businessOutTime;
    }

    public void setBusinessOutTime(Date businessOutTime) {
        this.businessOutTime = businessOutTime;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public Integer getSalesAuditStatus() {
        return salesAuditStatus;
    }

    public void setSalesAuditStatus(Integer salesAuditStatus) {
        this.salesAuditStatus = salesAuditStatus;
    }

    @Override
    public String toString() {
        return "PsiStorage{" +
                "id=" + id +
                ", supplyId=" + supplyId +
                ", supplierId=" + supplierId +
                ", supplierName='" + supplierName + '\'' +
                ", createUser=" + createUser +
                ", createUserName='" + createUserName + '\'' +
                ", tenantId=" + tenantId +
                ", tenantName='" + tenantName + '\'' +
                ", amount=" + amount +
                ", audit=" + audit +
                ", auditTime=" + auditTime +
                ", status=" + status +
                ", auditUser=" + auditUser +
                ", auditUserName='" + auditUserName + '\'' +
                ", remark='" + remark + '\'' +
                ", businessTime=" + businessTime +
                ", businessOutTime=" + businessOutTime +
                ", storeId=" + storeId +
                ", storeName='" + storeName + '\'' +
                ", salesAuditStatus=" + salesAuditStatus +
                '}';
    }
}
