package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 【请填写功能名称】对象 psi_summary
 * 
 * @author ruoyi
 * @date 2023-12-25
 */
public class PsiSummary extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 供应商id */
    @Excel(name = "供应商id")
    private Long supplierId;

    /** 供应商姓名 */
    @Excel(name = "供应商姓名")
    private String supplierName;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 租户姓名 */
    @Excel(name = "租户姓名")
    private String tenantName;

    /** 创建人 */
    @Excel(name = "创建人")
    private Long createUser;

    /** 创建人姓名 */
    @Excel(name = "创建人姓名")
    private String createUserName;

    /** 总金额 */
    @Excel(name = "总金额")
    private BigDecimal totalAmount;

    /** 统计年月 开始 */
    private String summaryDate;

    /** 备注 */
    private String remark;

    /** 类型 1:入库 2:出库 */
    private Integer type;

    // /** 入库汇总业务时间 */
    // @JsonFormat(pattern = "yyyy-MM-dd")
    // private Date businessTime;
    //
    // /** 出库汇总业务时间 */
    // @JsonFormat(pattern = "yyyy-MM-dd")
    // private Date businessOutTime;

    /** 仓库id */
    @Excel(name = "仓库id")
    private Long storeId;

    /** 仓库名称 */
    @Excel(name = "仓库名称")
    private String storeName;

    /**  业务开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date timePeriodStart;

    /**  业务结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date timePeriodEnd;


    public PsiSummary() {
    }

    public PsiSummary(Long id, Long supplierId, String supplierName, Long tenantId, String tenantName, Long createUser, String createUserName, BigDecimal totalAmount, String summaryDate, String remark, Integer type, Long storeId, String storeName, Date timePeriodStart, Date timePeriodEnd) {
        this.id = id;
        this.supplierId = supplierId;
        this.supplierName = supplierName;
        this.tenantId = tenantId;
        this.tenantName = tenantName;
        this.createUser = createUser;
        this.createUserName = createUserName;
        this.totalAmount = totalAmount;
        this.summaryDate = summaryDate;
        this.remark = remark;
        this.type = type;
        this.storeId = storeId;
        this.storeName = storeName;
        this.timePeriodStart = timePeriodStart;
        this.timePeriodEnd = timePeriodEnd;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    public BigDecimal getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(BigDecimal totalAmount) {
        this.totalAmount = totalAmount;
    }

    public String getSummaryDate() {
        return summaryDate;
    }

    public void setSummaryDate(String summaryDate) {
        this.summaryDate = summaryDate;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public Date getTimePeriodStart() {
        return timePeriodStart;
    }

    public void setTimePeriodStart(Date timePeriodStart) {
        this.timePeriodStart = timePeriodStart;
    }

    public Date getTimePeriodEnd() {
        return timePeriodEnd;
    }

    public void setTimePeriodEnd(Date timePeriodEnd) {
        this.timePeriodEnd = timePeriodEnd;
    }

    @Override
    public String toString() {
        return "PsiSummary{" +
                "id=" + id +
                ", supplierId=" + supplierId +
                ", supplierName='" + supplierName + '\'' +
                ", tenantId=" + tenantId +
                ", tenantName='" + tenantName + '\'' +
                ", createUser=" + createUser +
                ", createUserName='" + createUserName + '\'' +
                ", totalAmount=" + totalAmount +
                ", summaryDate='" + summaryDate + '\'' +
                ", remark='" + remark + '\'' +
                ", type=" + type +
                ", storeId=" + storeId +
                ", storeName='" + storeName + '\'' +
                ", timePeriodStart=" + timePeriodStart +
                ", timePeriodEnd=" + timePeriodEnd +
                '}';
    }
}
