package com.ruoyi.psi.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import java.math.BigDecimal;

/**
 * 汇总详细对象 psi_summary_item
 * 
 * @author ruoyi
 * @date 2023-12-25
 */
public class PsiSummaryItem extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 汇总表id */
    @Excel(name = "汇总表id")
    private Long summaryId;

    /** 商品id */
    @Excel(name = "商品id")
    private Long goodsId;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 商品执行价 */
    @Excel(name = "商品执行价")
    private BigDecimal priceInput;

    /** 规格 */
    @Excel(name = "规格")
    private String spec;

    /** 单位 */
    @Excel(name = "单位")
    private String unit;

    /** 商品总金额 */
    @Excel(name = "商品总金额")
    private BigDecimal goodsAmount;

    /** 本次入库数量 */
    @Excel(name = "本次入库数量")
    private BigDecimal thisQuantity;

    public PsiSummaryItem() {
    }

    public PsiSummaryItem(Long id, Long summaryId, Long goodsId, String goodsName, BigDecimal priceInput, String spec, String unit, BigDecimal goodsAmount, BigDecimal thisQuantity) {
        this.id = id;
        this.summaryId = summaryId;
        this.goodsId = goodsId;
        this.goodsName = goodsName;
        this.priceInput = priceInput;
        this.spec = spec;
        this.unit = unit;
        this.goodsAmount = goodsAmount;
        this.thisQuantity = thisQuantity;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSummaryId() {
        return summaryId;
    }

    public void setSummaryId(Long summaryId) {
        this.summaryId = summaryId;
    }

    public Long getGoodsId() {
        return goodsId;
    }

    public void setGoodsId(Long goodsId) {
        this.goodsId = goodsId;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public BigDecimal getPriceInput() {
        return priceInput;
    }

    public void setPriceInput(BigDecimal priceInput) {
        this.priceInput = priceInput;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public BigDecimal getGoodsAmount() {
        return goodsAmount;
    }

    public void setGoodsAmount(BigDecimal goodsAmount) {
        this.goodsAmount = goodsAmount;
    }

    public BigDecimal getThisQuantity() {
        return thisQuantity;
    }

    public void setThisQuantity(BigDecimal thisQuantity) {
        this.thisQuantity = thisQuantity;
    }

    @Override
    public String toString() {
        return "PsiSummaryItem{" +
                "id=" + id +
                ", summaryId=" + summaryId +
                ", goodsId=" + goodsId +
                ", goodsName='" + goodsName + '\'' +
                ", priceInput=" + priceInput +
                ", spec='" + spec + '\'' +
                ", unit='" + unit + '\'' +
                ", goodsAmount=" + goodsAmount +
                ", thisQuantity=" + thisQuantity +
                '}';
    }
}
