package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 供货单对象 psi_supply
 * 
 * @author ruoyi
 * @date 2023-12-14
 */
public class PsiSupply extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 创建人 */
    // @Excel(name = "创建人")
    private Long createUser;

    /** 供应商id */
    // @Excel(name = "供应商id")
    private Long supplierId;

    /** 采购单id */
    // @Excel(name = "采购单id")
    private Long purchaseId;

    /** 租户id */
    // @Excel(name = "租户id")
    private Long tenantId;

    /** 总金额 */
    @Excel(name = "总金额",scale = 2)
    private BigDecimal totalAmount;

    /** 真实金额*/
    private BigDecimal actualAmount;

    @Excel(name = "供应商名称")
    private String supplierName;

    /**备注 */
    @Excel(name = "备注")
    private String remark;

    /**状态  1已收货 0未收货*/
    @Excel(name = "收货状态",readConverterExp = "0=未收货,1=已收货")
    private Integer status;

    /** 创建人姓名*/
    private String createUsername;

    /** 租户姓名*/
    @Excel(name = "下单人姓名")
    private String tenantName;

    /** 库存总金额*/
    private BigDecimal storageAmount;

    /** 收货方式1：采购录入 2：手动录入*/
    private Integer deliveryMethod;

    /** 业务日期*/
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date businessTime;

    /** 仓库id */
    @Excel(name = "仓库id")
    private Long storeId;

    /** 仓库名称 */
    @Excel(name = "仓库名称")
    private String storeName;

    public PsiSupply() {
    }

    public PsiSupply(Long id, Long createUser, Long supplierId, Long purchaseId, Long tenantId, BigDecimal totalAmount, BigDecimal actualAmount, String supplierName, String remark, Integer status, String createUsername, String tenantName, BigDecimal storageAmount, Integer deliveryMethod, Date businessTime, Long storeId, String storeName) {
        this.id = id;
        this.createUser = createUser;
        this.supplierId = supplierId;
        this.purchaseId = purchaseId;
        this.tenantId = tenantId;
        this.totalAmount = totalAmount;
        this.actualAmount = actualAmount;
        this.supplierName = supplierName;
        this.remark = remark;
        this.status = status;
        this.createUsername = createUsername;
        this.tenantName = tenantName;
        this.storageAmount = storageAmount;
        this.deliveryMethod = deliveryMethod;
        this.businessTime = businessTime;
        this.storeId = storeId;
        this.storeName = storeName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Long getPurchaseId() {
        return purchaseId;
    }

    public void setPurchaseId(Long purchaseId) {
        this.purchaseId = purchaseId;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public BigDecimal getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(BigDecimal totalAmount) {
        this.totalAmount = totalAmount;
    }

    public BigDecimal getActualAmount() {
        return actualAmount;
    }

    public void setActualAmount(BigDecimal actualAmount) {
        this.actualAmount = actualAmount;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getCreateUsername() {
        return createUsername;
    }

    public void setCreateUsername(String createUsername) {
        this.createUsername = createUsername;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public BigDecimal getStorageAmount() {
        return storageAmount;
    }

    public void setStorageAmount(BigDecimal storageAmount) {
        this.storageAmount = storageAmount;
    }

    public Integer getDeliveryMethod() {
        return deliveryMethod;
    }

    public void setDeliveryMethod(Integer deliveryMethod) {
        this.deliveryMethod = deliveryMethod;
    }

    public Date getBusinessTime() {
        return businessTime;
    }

    public void setBusinessTime(Date businessTime) {
        this.businessTime = businessTime;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    @Override
    public String toString() {
        return "PsiSupply{" +
                "id=" + id +
                ", createUser=" + createUser +
                ", supplierId=" + supplierId +
                ", purchaseId=" + purchaseId +
                ", tenantId=" + tenantId +
                ", totalAmount=" + totalAmount +
                ", actualAmount=" + actualAmount +
                ", supplierName='" + supplierName + '\'' +
                ", remark='" + remark + '\'' +
                ", status=" + status +
                ", createUsername='" + createUsername + '\'' +
                ", tenantName='" + tenantName + '\'' +
                ", storageAmount=" + storageAmount +
                ", deliveryMethod=" + deliveryMethod +
                ", businessTime=" + businessTime +
                ", storeId=" + storeId +
                ", storeName=" + storeName +
                '}';
    }
}
