package com.ruoyi.psi.domain;

import java.math.BigDecimal;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 供货单详情对象 psi_supply_item
 * 
 * @author ruoyi
 * @date 2023-12-15
 */
public class PsiSupplyItem extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 关联的供货单id */
    @Excel(name = "关联的供货单id")
    private Long supplyId;

    /** 商品id */
    @Excel(name = "商品id")
    private Long goodsId;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 单位 */
    @Excel(name = "单位")
    private String unit;

    /** 规格 */
    @Excel(name = "规格")
    private String spec;

    /** 数量 */
    @Excel(name = "数量")
    private BigDecimal quantity;

    // 实际收货
    private BigDecimal actualQuantity;

    /** 合同单价 */
    @Excel(name = "合同单价")
    private BigDecimal price;

    /** 执行单价 */
    @Excel(name = "执行单价")
    private BigDecimal priceInput;

    /** 金额 执行单价*数量 */
    @Excel(name = "金额 执行单价*数量")
    private BigDecimal amount;

    /**生产日期 */
    private String productionDate;

    /**保质期 */
    private String shelfLife;

    /**产地 */
    private String origin;

    /** 入库数量*/
    private BigDecimal storageQuantity;

    /** 本次入库数量*/
    private BigDecimal thisQuantity;


    public PsiSupplyItem() {
    }

    public PsiSupplyItem(Long id, Long supplyId, Long goodsId, String goodsName, String unit, String spec, BigDecimal quantity, BigDecimal actualQuantity, BigDecimal price, BigDecimal priceInput, BigDecimal amount, String productionDate, String shelfLife, String origin, BigDecimal storageQuantity, BigDecimal thisQuantity) {
        this.id = id;
        this.supplyId = supplyId;
        this.goodsId = goodsId;
        this.goodsName = goodsName;
        this.unit = unit;
        this.spec = spec;
        this.quantity = quantity;
        this.actualQuantity = actualQuantity;
        this.price = price;
        this.priceInput = priceInput;
        this.amount = amount;
        this.productionDate = productionDate;
        this.shelfLife = shelfLife;
        this.origin = origin;
        this.storageQuantity = storageQuantity;
        this.thisQuantity = thisQuantity;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSupplyId() {
        return supplyId;
    }

    public void setSupplyId(Long supplyId) {
        this.supplyId = supplyId;
    }

    public Long getGoodsId() {
        return goodsId;
    }

    public void setGoodsId(Long goodsId) {
        this.goodsId = goodsId;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    public BigDecimal getActualQuantity() {
        return actualQuantity;
    }

    public void setActualQuantity(BigDecimal actualQuantity) {
        this.actualQuantity = actualQuantity;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public BigDecimal getPriceInput() {
        return priceInput;
    }

    public void setPriceInput(BigDecimal priceInput) {
        this.priceInput = priceInput;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public String getProductionDate() {
        return productionDate;
    }

    public void setProductionDate(String productionDate) {
        this.productionDate = productionDate;
    }

    public String getShelfLife() {
        return shelfLife;
    }

    public void setShelfLife(String shelfLife) {
        this.shelfLife = shelfLife;
    }

    public String getOrigin() {
        return origin;
    }

    public void setOrigin(String origin) {
        this.origin = origin;
    }

    public BigDecimal getStorageQuantity() {
        return storageQuantity;
    }

    public void setStorageQuantity(BigDecimal storageQuantity) {
        this.storageQuantity = storageQuantity;
    }

    public BigDecimal getThisQuantity() {
        return thisQuantity;
    }

    public void setThisQuantity(BigDecimal thisQuantity) {
        this.thisQuantity = thisQuantity;
    }

    @Override
    public String toString() {
        return "PsiSupplyItem{" +
                "id=" + id +
                ", supplyId=" + supplyId +
                ", goodsId=" + goodsId +
                ", goodsName='" + goodsName + '\'' +
                ", unit='" + unit + '\'' +
                ", spec='" + spec + '\'' +
                ", quantity=" + quantity +
                ", actualQuantity=" + actualQuantity +
                ", price=" + price +
                ", priceInput=" + priceInput +
                ", amount=" + amount +
                ", productionDate='" + productionDate + '\'' +
                ", shelfLife='" + shelfLife + '\'' +
                ", origin='" + origin + '\'' +
                ", storageQuantity=" + storageQuantity +
                ", thisQuantity=" + thisQuantity +
                '}';
    }
}
