package com.ruoyi.psi.domain.vo;

import com.ruoyi.common.annotation.Excel;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @ClassName PsiSrorageItemVO
 * @Description
 * @Author fm
 * @Date 2023/12/28 19:17
 * @Version V1.0
 */
public class PsiSrorageItemVO {

    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 商品id */
    // @Excel(name = "商品编号")
    private Long goodsId;

    /** 业务日期 */
    @Excel(name = "业务日期", dateFormat = "yyyy-MM-dd")
    private Date businessTime;

    /** 仓库名称 */
    @Excel(name = "仓库名称")
    private String storeName;

    /** 供应商名称 */
    @Excel(name = "供应商名称")
    private String supplierName;

    /** 备注 */
    @Excel(name = "摘要")
    private String remark;

    /** 入库单id */
    @Excel(name = "单据编号")
    private Long storageId;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 单位 */
    @Excel(name = "单位")
    private String unit;

    /** 规格 */
    @Excel(name = "规格")
    private String spec;

    /** 实际数量 */
    // @Excel(name = "实际数量")
    private BigDecimal actualQuantity;

    /** 金额 */
    // @Excel(name = "金额")
    private BigDecimal price;

    /** 执行单价 */
    @Excel(name = "执行单价",scale = 2)
    private BigDecimal priceInput;

    /** 生产日期 */
    // @Excel(name = "生产日期")
    private String productionDate;

    /** 保质期 */
    // @Excel(name = "保质期")
    private String shelfLife;

    /** 产地 */
    // @Excel(name = "产地")
    private String origin;

    /** 收货单详情id */
    // @Excel(name = "收货单详情id")
    private Long supplyItemId;

    /** 已入库数量 */
    @Excel(name = "入库数量",scale = 2)
    private BigDecimal thisQuantity;

    private BigDecimal storageQuantity;

    /** 状态 0:未出库,1:已出库 */
    private Integer status;

    /** 批次 */
    private Long batch;

    /** 租户id*/
    private Long tenantId;

    /** 数量*/
    private BigDecimal quantity;

    @Excel(name = "入库金额",scale = 2)
    /** 金额 */
    private BigDecimal amount;

    public PsiSrorageItemVO() {
    }

    public PsiSrorageItemVO(Long id, Long storageId, Long goodsId, Date businessTime, String storeName, String supplierName, String remark, String goodsName, String unit, String spec, BigDecimal actualQuantity, BigDecimal price, BigDecimal priceInput, String productionDate, String shelfLife, String origin, Long supplyItemId, BigDecimal thisQuantity, BigDecimal storageQuantity, Integer status, Long batch, Long tenantId, BigDecimal quantity, BigDecimal amount) {
        this.id = id;
        this.storageId = storageId;
        this.goodsId = goodsId;
        this.businessTime = businessTime;
        this.storeName = storeName;
        this.supplierName = supplierName;
        this.remark = remark;
        this.goodsName = goodsName;
        this.unit = unit;
        this.spec = spec;
        this.actualQuantity = actualQuantity;
        this.price = price;
        this.priceInput = priceInput;
        this.productionDate = productionDate;
        this.shelfLife = shelfLife;
        this.origin = origin;
        this.supplyItemId = supplyItemId;
        this.thisQuantity = thisQuantity;
        this.storageQuantity = storageQuantity;
        this.status = status;
        this.batch = batch;
        this.tenantId = tenantId;
        this.quantity = quantity;
        this.amount = amount;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getStorageId() {
        return storageId;
    }

    public void setStorageId(Long storageId) {
        this.storageId = storageId;
    }

    public Long getGoodsId() {
        return goodsId;
    }

    public void setGoodsId(Long goodsId) {
        this.goodsId = goodsId;
    }

    public Date getBusinessTime() {
        return businessTime;
    }

    public void setBusinessTime(Date businessTime) {
        this.businessTime = businessTime;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public BigDecimal getActualQuantity() {
        return actualQuantity;
    }

    public void setActualQuantity(BigDecimal actualQuantity) {
        this.actualQuantity = actualQuantity;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public BigDecimal getPriceInput() {
        return priceInput;
    }

    public void setPriceInput(BigDecimal priceInput) {
        this.priceInput = priceInput;
    }

    public String getProductionDate() {
        return productionDate;
    }

    public void setProductionDate(String productionDate) {
        this.productionDate = productionDate;
    }

    public String getShelfLife() {
        return shelfLife;
    }

    public void setShelfLife(String shelfLife) {
        this.shelfLife = shelfLife;
    }

    public String getOrigin() {
        return origin;
    }

    public void setOrigin(String origin) {
        this.origin = origin;
    }

    public Long getSupplyItemId() {
        return supplyItemId;
    }

    public void setSupplyItemId(Long supplyItemId) {
        this.supplyItemId = supplyItemId;
    }

    public BigDecimal getThisQuantity() {
        return thisQuantity;
    }

    public void setThisQuantity(BigDecimal thisQuantity) {
        this.thisQuantity = thisQuantity;
    }

    public BigDecimal getStorageQuantity() {
        return storageQuantity;
    }

    public void setStorageQuantity(BigDecimal storageQuantity) {
        this.storageQuantity = storageQuantity;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Long getBatch() {
        return batch;
    }

    public void setBatch(Long batch) {
        this.batch = batch;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public BigDecimal getQuantity() {
        return quantity;
    }

    public void setQuantity(BigDecimal quantity) {
        this.quantity = quantity;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    @Override
    public String toString() {
        return "PsiSrorageItemVO{" +
                "id=" + id +
                ", storageId=" + storageId +
                ", goodsId=" + goodsId +
                ", businessTime=" + businessTime +
                ", storeName='" + storeName + '\'' +
                ", supplierName='" + supplierName + '\'' +
                ", remark='" + remark + '\'' +
                ", goodsName='" + goodsName + '\'' +
                ", unit='" + unit + '\'' +
                ", spec='" + spec + '\'' +
                ", actualQuantity=" + actualQuantity +
                ", price=" + price +
                ", priceInput=" + priceInput +
                ", productionDate='" + productionDate + '\'' +
                ", shelfLife='" + shelfLife + '\'' +
                ", origin='" + origin + '\'' +
                ", supplyItemId=" + supplyItemId +
                ", thisQuantity=" + thisQuantity +
                ", storageQuantity=" + storageQuantity +
                ", status=" + status +
                ", batch=" + batch +
                ", tenantId=" + tenantId +
                ", quantity=" + quantity +
                ", amount=" + amount +
                '}';
    }
}