package com.ruoyi.psi.domain.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @ClassName StorageNumberVO
 * @Description
 * @Author fm
 * @Date 2024/2/26 10:27
 * @Version V1.0
 */
public class StorageNumberVO extends BaseEntity {

    /** 商品id */
    private Long goodsId;

    /** 仓库名称 */
    @Excel(name = "仓库名称")
    private String storeName;

    /** 业务日期*/
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date businessTime;

    /** 供应商id */
    private Long supplierId;

    /** 仓库id*/
    private Long storeId;

    /** 供应商名称 */
    @Excel(name = "供应商名称")
    private String supplierName;

    /** 备注 */
    @Excel(name = "摘要")
    private String remark;

    /** 采购员 */
    @Excel(name = "采购员")
    private String createUserName;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 规格 */
    @Excel(name = "规格")
    private String spec;

    /** 单位 */
    @Excel(name = "单位")
    private String unit;

    /** 实际数量 */
    @Excel(name = "收货数量", scale = 2)
    private BigDecimal actualQuantity;

    /** 已入库 */
    @Excel(name = "已入库数量", scale = 2)
    private BigDecimal storageQuantity;

    /** 未入库数量 */
    @Excel(name = "未入库数量", scale = 2)
    private BigDecimal noWarehousing;

    /** 金额 */
    @Excel(name = "合同价", scale = 2)
    private BigDecimal price;

    /** 执行单价 */
    @Excel(name = "执行价", scale = 2)
    private BigDecimal priceInput;

    /** 租户id */
    private Long tenantId;

    public StorageNumberVO() {
    }

    public StorageNumberVO(Long goodsId, String storeName, Date businessTime, Long supplierId, Long storeId, String supplierName, String remark, String goodsName, String unit, String spec, BigDecimal actualQuantity, BigDecimal storageQuantity, BigDecimal price, BigDecimal priceInput, Long tenantId, BigDecimal noWarehousing, String createUserName) {
        this.goodsId = goodsId;
        this.storeName = storeName;
        this.businessTime = businessTime;
        this.supplierId = supplierId;
        this.storeId = storeId;
        this.supplierName = supplierName;
        this.remark = remark;
        this.goodsName = goodsName;
        this.unit = unit;
        this.spec = spec;
        this.actualQuantity = actualQuantity;
        this.storageQuantity = storageQuantity;
        this.price = price;
        this.priceInput = priceInput;
        this.tenantId = tenantId;
        this.noWarehousing = noWarehousing;
        this.createUserName = createUserName;
    }

    public Long getGoodsId() {
        return goodsId;
    }

    public void setGoodsId(Long goodsId) {
        this.goodsId = goodsId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public Date getBusinessTime() {
        return businessTime;
    }

    public void setBusinessTime(Date businessTime) {
        this.businessTime = businessTime;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Long getStoreId() {
        return storeId;
    }

    public void setStoreId(Long storeId) {
        this.storeId = storeId;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public BigDecimal getActualQuantity() {
        return actualQuantity;
    }

    public void setActualQuantity(BigDecimal actualQuantity) {
        this.actualQuantity = actualQuantity;
    }

    public BigDecimal getStorageQuantity() {
        return storageQuantity;
    }

    public void setStorageQuantity(BigDecimal storageQuantity) {
        this.storageQuantity = storageQuantity;
    }

    public BigDecimal getPrice() {
        return price;
    }

    public void setPrice(BigDecimal price) {
        this.price = price;
    }

    public BigDecimal getPriceInput() {
        return priceInput;
    }

    public void setPriceInput(BigDecimal priceInput) {
        this.priceInput = priceInput;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public BigDecimal getNoWarehousing() {
        return noWarehousing;
    }

    public void setNoWarehousing(BigDecimal noWarehousing) {
        this.noWarehousing = noWarehousing;
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }
}