package com.ruoyi.psi.domain.vo;

import com.ruoyi.psi.domain.ApprovalRecording;
import com.ruoyi.psi.domain.PsiSrorageItem;
import com.ruoyi.psi.domain.PsiStorage;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @ClassName StorageVO
 * @Description
 * @Author fm
 * @Date 2023/12/23 15:30
 * @Version V1.0
 */
public class StorageVO extends PsiStorage {

    private List<PsiSrorageItem> items;

    /** 收货方式1：采购录入 2：手动录入*/
    private String deliveryMethod;

    /** 租户 id集合*/
    private List storeIds;

    /** 商品名称 */
    private String goodsName;

    /** 入库审批流程记录 */
    private List<ApprovalRecording> inApprovalRecordingList;

    /** 出库审批流程记录 */
    private List<ApprovalRecording> outApprovalRecordingList;

    /** 销货单流程记录 */
    private List<ApprovalRecording> salesApprovalRecordingList;

    public StorageVO() {
    }

    public StorageVO(List<PsiSrorageItem> items, String deliveryMethod, List storeIds, String goodsName, List<ApprovalRecording> inApprovalRecordingList, List<ApprovalRecording> outApprovalRecordingList, List<ApprovalRecording> salesApprovalRecordingList) {
        this.items = items;
        this.deliveryMethod = deliveryMethod;
        this.storeIds = storeIds;
        this.goodsName = goodsName;
        this.inApprovalRecordingList = inApprovalRecordingList;
        this.outApprovalRecordingList = outApprovalRecordingList;
        this.salesApprovalRecordingList = salesApprovalRecordingList;
    }

    public StorageVO(Long id, Long supplyId, Long supplierId, String supplierName, Long createUser, String createUserName, Long tenantId, String tenantName, BigDecimal amount, Integer audit, Date auditTime, Integer status, Long auditUser, String auditUserName, String remark, Date businessTime, Date businessOutTime, Long storeId, String storeName, Integer salesAuditStatus, List<PsiSrorageItem> items, String deliveryMethod, List storeIds, String goodsName, List<ApprovalRecording> inApprovalRecordingList, List<ApprovalRecording> outApprovalRecordingList, List<ApprovalRecording> salesApprovalRecordingList) {
        super(id, supplyId, supplierId, supplierName, createUser, createUserName, tenantId, tenantName, amount, audit, auditTime, status, auditUser, auditUserName, remark, businessTime, businessOutTime, storeId, storeName, salesAuditStatus);
        this.items = items;
        this.deliveryMethod = deliveryMethod;
        this.storeIds = storeIds;
        this.goodsName = goodsName;
        this.inApprovalRecordingList = inApprovalRecordingList;
        this.outApprovalRecordingList = outApprovalRecordingList;
        this.salesApprovalRecordingList = salesApprovalRecordingList;
    }

    public List<PsiSrorageItem> getItems() {
        return items;
    }

    public void setItems(List<PsiSrorageItem> items) {
        this.items = items;
    }

    public String getDeliveryMethod() {
        return deliveryMethod;
    }

    public void setDeliveryMethod(String deliveryMethod) {
        this.deliveryMethod = deliveryMethod;
    }

    public List getStoreIds() {
        return storeIds;
    }

    public void setStoreIds(List storeIds) {
        this.storeIds = storeIds;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public List<ApprovalRecording> getInApprovalRecordingList() {
        return inApprovalRecordingList;
    }

    public void setInApprovalRecordingList(List<ApprovalRecording> inApprovalRecordingList) {
        this.inApprovalRecordingList = inApprovalRecordingList;
    }

    public List<ApprovalRecording> getOutApprovalRecordingList() {
        return outApprovalRecordingList;
    }

    public void setOutApprovalRecordingList(List<ApprovalRecording> outApprovalRecordingList) {
        this.outApprovalRecordingList = outApprovalRecordingList;
    }

    public List<ApprovalRecording> getSalesApprovalRecordingList() {
        return salesApprovalRecordingList;
    }

    public void setSalesApprovalRecordingList(List<ApprovalRecording> salesApprovalRecordingList) {
        this.salesApprovalRecordingList = salesApprovalRecordingList;
    }
}