package com.ruoyi.psi.domain.vo;

import com.ruoyi.psi.domain.ApprovalRecording;
import com.ruoyi.psi.domain.PsiSummary;
import com.ruoyi.psi.domain.PsiSummaryItem;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @ClassName SummaryVO
 * @Description
 * @Author fm
 * @Date 2023/12/25 22:18
 * @Version V1.0
 */
public class SummaryVO extends PsiSummary {
    private List<PsiSummaryItem> summaryItems;

    private List<ApprovalRecording> inApprovalRecordingList;

    private List<ApprovalRecording> outApprovalRecordingList;


    public SummaryVO() {
    }

    public SummaryVO(List<PsiSummaryItem> summaryItems, List<ApprovalRecording> inApprovalRecordingList, List<ApprovalRecording> outApprovalRecordingList) {
        this.summaryItems = summaryItems;
        this.inApprovalRecordingList = inApprovalRecordingList;
        this.outApprovalRecordingList = outApprovalRecordingList;
    }

    public SummaryVO(Long id, Long supplierId, String supplierName, Long tenantId, String tenantName, Long createUser, String createUserName, BigDecimal totalAmount, String summaryDate, String remark, Integer type, Long storeId, String storeName, Date timePeriodStart, Date timePeriodEnd, List<PsiSummaryItem> summaryItems, List<ApprovalRecording> inApprovalRecordingList, List<ApprovalRecording> outApprovalRecordingList) {
        super(id, supplierId, supplierName, tenantId, tenantName, createUser, createUserName, totalAmount, summaryDate, remark, type, storeId, storeName, timePeriodStart, timePeriodEnd);
        this.summaryItems = summaryItems;
        this.inApprovalRecordingList = inApprovalRecordingList;
        this.outApprovalRecordingList = outApprovalRecordingList;
    }

    public List<PsiSummaryItem> getSummaryItems() {
        return summaryItems;
    }

    public void setSummaryItems(List<PsiSummaryItem> summaryItems) {
        this.summaryItems = summaryItems;
    }

    public List<ApprovalRecording> getInApprovalRecordingList() {
        return inApprovalRecordingList;
    }

    public void setInApprovalRecordingList(List<ApprovalRecording> inApprovalRecordingList) {
        this.inApprovalRecordingList = inApprovalRecordingList;
    }

    public List<ApprovalRecording> getOutApprovalRecordingList() {
        return outApprovalRecordingList;
    }

    public void setOutApprovalRecordingList(List<ApprovalRecording> outApprovalRecordingList) {
        this.outApprovalRecordingList = outApprovalRecordingList;
    }
}