package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.ApprovalProcess;
import org.apache.ibatis.annotations.Param;

/**
 * 审批流程Mapper接口
 * 
 * @author ruoyi
 * @date 2024-01-08
 */
public interface ApprovalProcessMapper 
{
    /**
     * 查询审批流程
     * @return 审批流程
     */
    public List<ApprovalProcess> selectApprovalProcessById(ApprovalProcess approvalProcess);

    /**
     * 查询审批流程列表
     * 
     * @param approvalProcess 审批流程
     * @return 审批流程集合
     */
    public List<ApprovalProcess> selectApprovalProcessList(ApprovalProcess approvalProcess);

    /**
     * 新增审批流程
     * 
     * @param approvalProcess 审批流程
     * @return 结果
     */
    public int insertApprovalProcess(ApprovalProcess approvalProcess);

    /**
     * 修改审批流程
     * 
     * @param approvalProcess 审批流程
     * @return 结果
     */
    public int updateApprovalProcess(ApprovalProcess approvalProcess);

    /**
     * 删除审批流程
     * 
     * @param id 审批流程主键
     * @return 结果
     */
    public int deleteApprovalProcessById(Long id);

    /**
     * 批量删除审批流程
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteApprovalProcessByIds(Long[] ids);

    /**
     * 批量更新审批流程
     * @param items
     * @param tenantId
     * @return
     */
    int insertBatchApprovalProcess(@Param("tenantId") Long tenantId, @Param("items") List<ApprovalProcess> items);

    /**
     * 删除审批流程
     * @param documentType
     * @param tenantId
     */
    void deleteByDocumentTypeAndTenantId(@Param("documentType") Integer documentType, @Param("tenantId") Long tenantId);
}
