package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.BiddingItem;
import org.apache.ibatis.annotations.Param;

/**
 * 竞价单详情Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-18
 */
public interface BiddingItemMapper 
{
    /**
     * 查询竞价单详情
     * 
     * @param id 竞价单详情主键
     * @return 竞价单详情
     */
    public List<BiddingItem> selectBiddingItemById(Long id);

    /**
     * 查询竞价单详情列表
     * 
     * @param BiddingItem 竞价单详情
     * @return 竞价单详情集合
     */
    public List<BiddingItem> selectBiddingItemList(BiddingItem BiddingItem);

    /**
     * 新增竞价单详情
     * 
     * @param BiddingItem 竞价单详情
     * @return 结果
     */
    public int insertBiddingItem(BiddingItem BiddingItem);

    /**
     * 修改竞价单详情
     * 
     * @param BiddingItem 竞价单详情
     * @return 结果
     */
    public int updateBiddingItem(BiddingItem BiddingItem);

    /**
     * 删除竞价单详情
     * 
     * @param id 竞价单详情主键
     * @return 结果
     */
    public int deleteBiddingItemById(Long id);

    /**
     * 批量删除竞价单详情
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBiddingItemByIds(Long[] ids);

    /**
     * 批量更新item
     * @param items
     * @return
     */
    int updateBiddingItemByList(@Param("items") List<BiddingItem> items);

}
