package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.Bidding;
import com.ruoyi.psi.domain.BiddingItem;
import org.apache.ibatis.annotations.Param;

/**
 * 竞价单Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-17
 */
public interface BiddingMapper 
{
    /**
     * 查询竞价单
     * 
     * @param id 竞价单主键
     * @return 竞价单
     */
    public Bidding selectBiddingById(Long id);

    /**
     * 查询竞价单列表
     * 
     * @param Bidding 竞价单
     * @return 竞价单集合
     */
    public List<Bidding> selectBiddingList(Bidding Bidding);

    /**
     * 新增竞价单
     * 
     * @param Bidding 竞价单
     * @return 结果
     */
    public int insertBidding(Bidding Bidding);

    /**
     * 修改竞价单
     * 
     * @param Bidding 竞价单
     * @return 结果
     */
    public int updateBidding(Bidding Bidding);

    /**
     * 删除竞价单
     * 
     * @param id 竞价单主键
     * @return 结果
     */
    public int deleteBiddingById(Long id);

    /**
     * 批量删除竞价单
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteBiddingByIds(Long[] ids);

    void savaBathList(@Param("items") List<BiddingItem> biddingItems, @Param("biddingId") Long biddingId);

    Bidding selectBiddingByIdAndTenantId(@Param("id") Long biddingId, @Param("supplierId") Long supplierId);

    List<Bidding> selectBiddingByPurchaseId(@Param("purchaseId") Long purchaseId);
}
