package com.ruoyi.psi.mapper;

import java.util.List;

import com.ruoyi.psi.domain.PsiPurchase;
import com.ruoyi.psi.domain.PsiPurchaseItem;
import org.apache.ibatis.annotations.Param;
import org.springframework.security.core.parameters.P;

/**
 * 采购订单明细Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-13
 */
public interface PsiPurchaseItemMapper 
{
    /**
     * 查询采购订单明细
     * 
     * @param id 采购订单明细主键
     * @return 采购订单明细
     */
    public PsiPurchaseItem selectPsiPurchaseItemById(Long id);

    /**
     * 查询采购订单明细列表
     * 
     * @param purchaseId 采购订单id
     * @return 采购订单明细集合
     */
    public List<PsiPurchaseItem> selectPsiPurchaseItemByPurchaseId(Long purchaseId);

    /**
     * 新增采购订单明细
     * 
     * @param psiPurchaseItem 采购订单明细
     * @return 结果
     */
    public int insertPsiPurchaseItem(PsiPurchaseItem psiPurchaseItem);

    /**
     * 批量新增采购订单明细
     *
     * @param purchaseId 采购订单id
     * @param items 采购订单明细
     * @return 结果
     */
    public int batchInsertItem(@Param("purchaseId") Long purchaseId, @Param("items") List<PsiPurchaseItem> items);

    /**
     * 删除采购订单明细
     * 
     * @param purchaseId 采购订单明细主键
     * @return 结果
     */
    public int deletePsiPurchaseItemByPurchaseId(Long purchaseId);

    /**
     * 根据采购单id集合查询符合条件的数据*
     * @param ids
     * @return
     */
    List<PsiPurchaseItem> selectPurchaseItemByIds(@Param("ids") List<Long> ids);

    /**
     * 汇总报表目录下采购明细
     * @param psiPurchase
     * @return
     */
    List<PsiPurchaseItem> selectPurchaseItem(PsiPurchase psiPurchase);
}
