package com.ruoyi.psi.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.psi.domain.PsiPurchase;
import com.ruoyi.psi.domain.PsiPurchaseItem;
import org.apache.ibatis.annotations.Param;

/**
 * 采购订单Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-13
 */
public interface PsiPurchaseMapper 
{
    /**
     * 查询采购订单
     * 
     * @param id 采购订单主键
     * @return 采购订单
     */
    public PsiPurchase selectPsiPurchaseById(@Param("id") Long id, @Param("tenantId") Long tenantId);

    /**
     * 查询采购订单列表
     * 
     * @param psiPurchase 采购订单
     * @return 采购订单集合
     */
    public List<PsiPurchase> selectPsiPurchaseList(PsiPurchase psiPurchase);

    /**
     * 查询采购订单列表
     *
     * @param psiPurchase 采购订单
     * @return 采购订单集合
     */
    public List<Map> selectMapResultList(PsiPurchase psiPurchase);

    /**
     * 新增采购订单
     * 
     * @param psiPurchase 采购订单
     * @return 结果
     */
    public int insertPsiPurchase(PsiPurchase psiPurchase);

    /**
     * 修改采购订单
     * 
     * @param psiPurchase 采购订单
     * @return 结果
     */
    public int updatePsiPurchase(PsiPurchase psiPurchase);

    /**
     * 删除采购订单
     * 
     * @param id 采购订单主键
     * @return 结果
     */
    public int deletePsiPurchaseById(@Param("id") Long id, @Param("tenantId") Long tenantId);

    /**
     * 批量删除采购订单
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiPurchaseByIds(@Param("ids") Long[] ids, @Param("tenantId") Long tenantId);

    /**
     * 查询符合条件的id集合
     * @param psiPurchase
     * @return
     */
    List<Long> selectPurchaseIds(PsiPurchase psiPurchase);

    /**
     * 根据id查询采购单*
     * @param documentId
     * @return
     */
    PsiPurchase selectOnePsipurchaseById(Long documentId);
}
