package com.ruoyi.psi.mapper;

import com.ruoyi.psi.domain.PsiSupply;
import com.ruoyi.psi.domain.PsiSupplyItem;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @ClassName PsiReceiptMapper
 * @Description \
 * @Author fm
 * @Date 2023/12/20 11:06
 * @Version V1.0
 */
public interface PsiReceiptMapper {

    /**
     * 修改供货单
     *
     * @param psiSupply 供货单
     * @return 结果
     */
    public int updatePsiSupply(PsiSupply psiSupply);

    /**
     * 删除item*
     * @param supplyId
     * @return
     */
    int deleteItem(Long supplyId);

    /**
     * 批量插入供货单详情
     *
     * @param supplyItems
     * @return
     */
    int insertSupplyItem(@Param("items") List<PsiSupplyItem> supplyItems);

    /**
     * 已收货*
     * @param psiSupply
     * @return
     */
    List<PsiSupply> selectList(PsiSupply psiSupply);

    /**
     * 已收货详细
     * @param id
     * @param tenantId
     * @return
     */
    PsiSupply selectPsiSupplyById(Long id, Long tenantId);

    /**
     * 详情*
     * @param id
     * @return
     */
    List<PsiSupplyItem> selectSupplyItem(Long id);


    /**
     * 新增供货单
     *
     * @param psiSupply 供货单
     * @return 结果
     */
    public int insertPsiSupply(PsiSupply psiSupply);

    /**
     * 批量插入供货单详情
     *
     * @param supplyItems
     * @return
     */
    int insertSupplyItem(@Param("items") List<PsiSupplyItem> supplyItems, @Param("supplyId") Long supplyId);

    /**
     * 已收货订单列表BU FEN YE*
     * @param psiSupply
     * @return
     */
    List<PsiSupply> selectAllList(PsiSupply psiSupply);


    Map<String, Object> getTotalAmount(PsiSupply psiSupply);
}