package com.ruoyi.psi.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.psi.domain.PsiPurchaseItem;
import com.ruoyi.psi.domain.PsiSrorageItem;
import com.ruoyi.psi.domain.PsiStorage;
import com.ruoyi.psi.domain.vo.PsiSrorageItemVO;
import com.ruoyi.psi.domain.vo.StorageItemExportVO;
import com.ruoyi.psi.domain.vo.StorageVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.security.core.parameters.P;

/**
 * 入库单详情Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public interface PsiSrorageItemMapper 
{
    /**
     * 查询入库单详情
     * 
     * @param id 入库单详情主键
     * @return 入库单详情
     */
    public PsiSrorageItem selectPsiSrorageItemById(Long id);

    /**
     * 查询入库单详情列表
     * 
     * @param psiSrorageItem 入库单详情
     * @return 入库单详情集合
     */
    public List<PsiSrorageItem> selectPsiSrorageItemList(PsiSrorageItem psiSrorageItem);

    /**
     * 新增入库单详情
     * 
     * @param psiSrorageItem 入库单详情
     * @return 结果
     */
    public int insertPsiSrorageItem(PsiSrorageItem psiSrorageItem);

    /**
     * 修改入库单详情
     * 
     * @param psiSrorageItem 入库单详情
     * @return 结果
     */
    public int updatePsiSrorageItem(PsiSrorageItem psiSrorageItem);

    /**
     * 删除入库单详情
     * 
     * @param id 入库单详情主键
     * @return 结果
     */
    public int deletePsiSrorageItemById(Long id);

    /**
     * 批量删除入库单详情
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiSrorageItemByIds(Long[] ids);

    void insertSrorageItem(@Param("items") List<PsiSrorageItem> srorageItems, @Param("storageId") Long storageId);

    void deleteItem(Long id);

    List<PsiSrorageItem> selectPsiStorageItemByStorageId(Long id);

    /**
     * 根据入库单id查看详情
     * @param id
     * @return
     */
    List<PsiSrorageItem> selectsrorageItemByStorageId(Long id);

    /**
     * 查询商品出库批次*
     * @param goodsId
     * @return
     */
    Integer selectBatchByGoodsId(@Param("goodsId") Long goodsId,@Param("tenantId") Long tenantId);

    /**
     * 批量更新
     * @param items
     * @return
     */
    Integer updateByItems(@Param("items") List<PsiSrorageItem> items);

    /**
     * 导出入库单详细*
     * @param id
     * @return
     */
    List<StorageItemExportVO> exportStorageItem(Long id);

    /**
     * 获得详细 根据id集合
     *
     * @param ids
     * @return
     */
    List<PsiSrorageItem> getInfoByIds(@Param("ids") List<Long> ids);

    /**
     * 汇总报表，目录下入库明细 导出
     * @param psiStorage
     * @return
     */
    List<PsiSrorageItemVO> exportQueryListAll(StorageVO psiStorage);

    List<PsiSrorageItem> selectOutboundStorageItemByStorageId(Long id);

    List<StorageItemExportVO> exportItem(PsiStorage psiStorage);

    int updateStatus(Long id);

    /**
     * 根据收货单id删除入库单明细
     * @param supplyId
     * @return
     */
    int deleteItemBySupplyId(Long supplyId);

    List<StorageItemExportVO> exportStorageItems(PsiSrorageItem psiSrorageItem);

    /**
     * *
     * @param psiStorage
     * @return
     */
    List<PsiSrorageItem> getInfo(StorageVO psiStorage);
}
