package com.ruoyi.psi.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.psi.domain.PsiSrorageItem;
import com.ruoyi.psi.domain.PsiStorage;
import com.ruoyi.psi.domain.vo.StorageNumberVO;
import com.ruoyi.psi.domain.vo.StorageVO;
import org.apache.ibatis.annotations.Param;

/**
 * 入库单Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public interface PsiStorageMapper 
{
    /**
     * 查询入库单
     * 
     * @param id 入库单主键
     * @return 入库单
     */
    public PsiStorage selectPsiStorageById(Long id);

    /**
     * 查询入库单列表
     * 
     * @param psiStorage 入库单
     * @return 入库单集合
     */
    public List<PsiStorage> selectPsiStorageList(PsiStorage psiStorage, List tenantIds);

    /**
     * 新增入库单
     * 
     * @param psiStorage 入库单
     * @return 结果
     */
    public int insertPsiStorage(PsiStorage psiStorage);

    /**
     * 修改
     * 
     * @param psiStorage 入库单
     * @return 结果
     */
    public int updatePsiStorage(PsiStorage psiStorage);

    /**
     * 删除入库单
     * 
     * @param id 入库单主键
     * @return 结果
     */
    public int deletePsiStorageById(Long id);

    /**
     * 批量删除入库单
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiStorageByIds(Long[] ids);

    // 查询是否是第一次入库
    int selectBySupplyId(Long id);

    /**
     * 月度汇总*
     * @param param
     * @return
     */
    List<Map> storageList(Map param);

    /**
     * 查询ids
     * @param psiStorage
     * @return
     */
    List<Long> selectIds(PsiStorage psiStorage);

    /**
     * 根据id集合查询所有的入库单
     * @param ids
     * @return
     */
    List<PsiStorage> getInfoByIds(@Param("ids") List<Long> ids);

    /**
     * 查询volist*
     * @param psiStorage
     * @return
     */
    List<StorageVO> selectPsiStorageVoList(StorageVO psiStorage);

    /**
     * 出库列表
     * @param psiStorage
     * @return
     */
    List<StorageVO> selectPsiOutboundList(StorageVO psiStorage);

    /**
     * 出库详细
     * @param id
     * @return
     */
    StorageVO getOutboundInfoById(Long id);

    int updateStatus(Long id);

    /**
     * 根据收货单id删除入库单
     * @param supplyId
     * @return
     */
    int deletePsiStorageBySupplyId(Long supplyId);

    /**
     * 获得列表总金额
     * @param psiStorage
     * @return
     */
    Map<String, Object> getTotalAmount(StorageVO psiStorage);

    Map<String, Object> selectPsiOutboundTotalAmountMap(StorageVO psiStorage);

    /**
     * 库存数量列表
     * @param storageNumberVO
     * @return
     */
    List<StorageNumberVO> listInventoryQuantity(StorageNumberVO storageNumberVO);

}
