package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.PsiStore;
import org.apache.ibatis.annotations.Param;

/**
 * 仓库Mapper接口
 * 
 * @author ruoyi
 * @date 2024-01-03
 */
public interface PsiStoreMapper 
{
    /**
     * 查询仓库
     * 
     * @param storeId 仓库主键
     * @return 仓库
     */
    public PsiStore selectPsiStoreByStoreId(@Param("storeId") Long storeId, @Param("tenantId") Long tenantId);

    /**
     * 查询仓库列表
     * 
     * @param psiStore 仓库
     * @return 仓库集合
     */
    public List<PsiStore> selectPsiStoreList(PsiStore psiStore);

    /**
     * 新增仓库
     * 
     * @param psiStore 仓库
     * @return 结果
     */
    public int insertPsiStore(PsiStore psiStore);

    /**
     * 修改仓库
     * 
     * @param psiStore 仓库
     * @return 结果
     */
    public int updatePsiStore(PsiStore psiStore);

    /**
     * 删除仓库
     * 
     * @param storeId 仓库主键
     * @return 结果
     */
    public int deletePsiStoreByStoreId(@Param("storeId") Long storeId, @Param("tenantId") Long tenantId);

    /**
     * 批量删除仓库
     * 
     * @param storeIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiStoreByStoreIds(@Param("ids") Long[] storeIds, @Param("tenantId") Long tenantId);

    /**
     * 根据收货单id 查询入库单id*
     * @param supplyId
     * @param tenantId
     * @return
     */
    List<Long> selectStorageIdBySupplyId(@Param("supplyId") Long supplyId, @Param("tenantId")Long tenantId);
}
