package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.PsiSummaryItem;
import org.apache.ibatis.annotations.Param;

/**
 * 汇总详细Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-25
 */
public interface PsiSummaryItemMapper 
{
    /**
     * 查询汇总详细
     * 
     * @param id 汇总详细主键
     * @return 汇总详细
     */
    public PsiSummaryItem selectPsiSummaryItemById(Long id);

    /**
     * 查询汇总详细列表
     * 
     * @param psiSummaryItem 汇总详细
     * @return 汇总详细集合
     */
    public List<PsiSummaryItem> selectPsiSummaryItemList(PsiSummaryItem psiSummaryItem);

    /**
     * 新增汇总详细
     * 
     * @param psiSummaryItem 汇总详细
     * @return 结果
     */
    public int insertPsiSummaryItem(PsiSummaryItem psiSummaryItem);

    /**
     * 修改汇总详细
     * 
     * @param psiSummaryItem 汇总详细
     * @return 结果
     */
    public int updatePsiSummaryItem(PsiSummaryItem psiSummaryItem);

    /**
     * 删除汇总详细
     * 
     * @param id 汇总详细主键
     * @return 结果
     */
    public int deletePsiSummaryItemById(Long id);

    public int deletePsiSummaryItemBySummaryId(Long summaryId);

    /**
     * 批量删除汇总详细
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiSummaryItemByIds(Long[] ids);

    /**
     * 批量插入明细*
     * @param items
     */
    void insertPsiSummaryItemByList(@Param("items") List<PsiSummaryItem> items,@Param("summaryId") Long summaryId);

    /**
     * 根据汇总主表id查看详情*
     * @param id
     * @return
     */
    List<PsiSummaryItem> selectSummaryItemBySummaryId(Long id);
}
