package com.ruoyi.psi.mapper;

import java.util.List;
import java.util.Map;

import com.ruoyi.psi.domain.PsiSummary;
import org.apache.ibatis.annotations.Param;

/**
 * 汇总Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-25
 */
public interface PsiSummaryMapper 
{
    /**
     * 查询汇总
     * 
     * @param id 汇总主键
     * @return 汇总
     */
    public PsiSummary selectPsiSummaryById(Long id);

    /**
     * 查询汇总列表
     * 
     * @param psiSummary 汇总
     * @return 汇总集合
     */
    public List<PsiSummary> selectPsiSummaryList(PsiSummary psiSummary);

    /**
     * 新增汇总
     * 
     * @param psiSummary 汇总
     * @return 结果
     */
    public int insertPsiSummary(PsiSummary psiSummary);

    /**
     * 修改汇总
     * 
     * @param psiSummary 汇总
     * @return 结果
     */
    public int updatePsiSummary(PsiSummary psiSummary);

    /**
     * 删除汇总
     * 
     * @param id 汇总主键
     * @return 结果
     */
    public int deletePsiSummaryById(Long id);

    /**
     * 批量删除汇总
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiSummaryByIds(Long[] ids);

    /**
     * 插入中间表*
     * @param summaryId
     * @param ids
     */
    void insertSummaryStorageRef(@Param("summaryId") Long summaryId, @Param("storageIds") List<Long> ids);

    /**
     * 删除中间表数据
     * @param id
     */
    void deletePsiSummaryStorageRef(Long id);

    /**
     * 获得入库汇总总金额
     * @param psiSummary
     * @return
     */
    Map<String, Object> getTotalAmount(PsiSummary psiSummary);
}
