package com.ruoyi.psi.mapper;

import java.util.List;
import com.ruoyi.psi.domain.PsiSupplyItem;

/**
 * 供货单详情Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public interface PsiSupplyItemMapper 
{
    /**
     * 查询供货单详情
     * 
     * @param id 供货单详情主键
     * @return 供货单详情
     */
    public PsiSupplyItem selectPsiSupplyItemById(Long id);

    /**
     * 查询供货单详情列表
     * 
     * @param psiSupplyItem 供货单详情
     * @return 供货单详情集合
     */
    public List<PsiSupplyItem> selectPsiSupplyItemList(PsiSupplyItem psiSupplyItem);

    /**
     * 新增供货单详情
     * 
     * @param psiSupplyItem 供货单详情
     * @return 结果
     */
    public int insertPsiSupplyItem(PsiSupplyItem psiSupplyItem);

    /**
     * 修改供货单详情
     * 
     * @param psiSupplyItem 供货单详情
     * @return 结果
     */
    public int updateSupplyItemStorageQuantity(PsiSupplyItem psiSupplyItem);

    /**
     * 删除供货单详情
     * 
     * @param id 供货单详情主键
     * @return 结果
     */
    public int deletePsiSupplyItemById(Long id);

    /**
     * 批量删除供货单详情
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiSupplyItemByIds(Long[] ids);

    /**
     * 重置收货单明细表已收货数量
     * @param id
     * @return
     */
    int resetSupplyItemStorageQuantity(Long id);

    int deletePsiSupplyItemBySupplyId(Long supplyId);

    /**
     * 修改收货单明细到未收货状态
     * @param supplyId
     * @return
     */
    int revokeSupplyItemToOrdering(Long supplyId);
}
