package com.ruoyi.psi.service;

import java.util.List;
import com.ruoyi.psi.domain.ApprovalProcess;

/**
 * 审批流程Service接口
 * 
 * @author ruoyi
 * @date 2024-01-08
 */
public interface IApprovalProcessService 
{
    /**
     * 查询审批流程
     * 
     * @param
     * @return 审批流程
     */
    public List<ApprovalProcess> selectApprovalProcessById(ApprovalProcess approvalProcess);

    /**
     * 查询审批流程列表
     * 
     * @param approvalProcess 审批流程
     * @return 审批流程集合
     */
    public List<ApprovalProcess> selectApprovalProcessList(ApprovalProcess approvalProcess);

    /**
     * 新增审批流程
     * 
     * @param approvalProcess 审批流程
     * @return 结果
     */
    public int insertApprovalProcess(ApprovalProcess approvalProcess);

    /**
     * 修改审批流程
     *
     * @return 结果
     */
    public int updateApprovalProcess(List<ApprovalProcess> approvalProcessList, Long tenantId);

    /**
     * 批量删除审批流程
     * 
     * @param ids 需要删除的审批流程主键集合
     * @return 结果
     */
    public int deleteApprovalProcessByIds(Long[] ids);

    /**
     * 删除审批流程信息
     * 
     * @param id 审批流程主键
     * @return 结果
     */
    public int deleteApprovalProcessById(Long id);

}
