package com.ruoyi.psi.service;

import java.util.List;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.psi.domain.ApprovalRecording;
import com.ruoyi.psi.domain.vo.ApprovalRecordingVO;

/**
 * 审批记录Service接口
 * 
 * @author ruoyi
 * @date 2024-01-19
 */
public interface IApprovalRecordingService 
{
    /**
     * 查询审批记录
     * @return 审批记录
     */
    public List<ApprovalRecording> selectApprovalRecordingById(ApprovalRecording approvalRecording);

    /**
     * 查询审批记录列表
     * 
     * @param approvalRecording 审批记录
     * @return 审批记录集合
     */
    public List<ApprovalRecordingVO> selectApprovalRecordingList(ApprovalRecording approvalRecording);

    /**
     * 新增审批记录
     * 
     * @param approvalRecording 审批记录
     * @return 结果
     */
    public int insertApprovalRecording(List<ApprovalRecording> approvalRecording);

    /**
     * 修改审批记录
     * 
     * @param approvalRecordings 审批记录
     * @return 结果
     */
    public int updateApprovalRecording(List<ApprovalRecording> approvalRecordings, Long tenantId);

    /**
     * 批量删除审批记录
     * 
     * @param ids 需要删除的审批记录主键集合
     * @return 结果
     */
    public int deleteApprovalRecordingByIds(Long[] ids);

    /**
     * 查询未审批记录(审批按钮)
     * @param approvalRecording
     * @return
     */
    public ApprovalRecording selectApprovalRecordingNoApproval(ApprovalRecording approvalRecording);

    /**
     * 获取单据详情*
     * @param documentId
     * @param documentType
     * @return
     */
    AjaxResult psiGetRecordingInfo(Long documentId, Integer documentType);

    /**
     * 已办列表
     * @param approvalRecording
     * @return
     */
    List<ApprovalRecordingVO> selectApprovalDoneRecordingList(ApprovalRecording approvalRecording);

    /**
     * 删除审批记录信息
     * 
     * @param id 审批记录主键
     * @return 结果
     */
    // public int deleteApprovalRecordingById(Long id);
}
