package com.ruoyi.psi.service;

import java.util.List;
import com.ruoyi.psi.domain.PsiGoods;
import com.ruoyi.psi.domain.dto.ImportRequestDTO;
import com.ruoyi.psi.domain.dto.PsiGoodsDTO;

/**
 * 商品Service接口
 * 
 * @author ruoyi
 * @date 2023-12-12
 */
public interface IPsiGoodsService 
{
    /**
     * 查询商品
     * 
     * @param id 商品主键
     * @return 商品
     */
    public PsiGoods selectPsiGoodsById(Long id,Long tenantId);

    /**
     * 查询商品列表
     * 
     * @param psiGoods 商品
     * @return 商品集合
     */
    public List<PsiGoods> selectPsiGoodsList(PsiGoods psiGoods);

    /**
     * 新增商品
     * 
     * @param psiGoods 商品
     * @return 结果
     */
    public int insertPsiGoods(PsiGoodsDTO psiGoods);

    /**
     * 修改商品
     * 
     * @param psiGoods 商品
     * @return 结果
     */
    public int updatePsiGoods(PsiGoodsDTO psiGoods);

    /**
     * 批量删除商品
     * 
     * @param ids 需要删除的商品主键集合
     * @return 结果
     */
    public int deletePsiGoodsByIds(Long[] ids,Long tenantId);

    /**
     * 删除商品信息
     * 
     * @param id 商品主键
     * @return 结果
     */
    public int deletePsiGoodsById(Long id, Long tenantId);

    /**
     * 导入商品
     * @param psiGoodsList
     *
     * @return
     */
    public String importPsiGoods(List<PsiGoods> psiGoodsList, Long tenantId, ImportRequestDTO requestDTO);

    /**
     * 查询商品列表(不分页)
     *
     * @param psiGoods
     * @return
     */
    List<PsiGoods> listAll(PsiGoods psiGoods);

    /**
     * 导出商品
     * @param psiGoods
     * @return
     */
    List<PsiGoods> selectExportPsiGoodsList(PsiGoods psiGoods);

    /**
     * 商品列表*
     * @param psiGoods
     * @return
     */
    List<PsiGoods> goodsList(PsiGoods psiGoods);

    /**
     * 撤回商品审核
     * @param psiGoods
     * @return
     */
    int revokePsiGoods(PsiGoods psiGoods);
}
