package com.ruoyi.psi.service;

import com.ruoyi.psi.domain.PsiPurchaseItem;
import com.ruoyi.psi.domain.PsiSrorageItem;
import com.ruoyi.psi.domain.PsiStorage;
import com.ruoyi.psi.domain.vo.*;

import java.util.List;
import java.util.Map;

/**
 * 入库单Service接口
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public interface IPsiStorageService 
{
    /**
     * 查询入库单
     * 
     * @param id 入库单主键
     * @return 入库单
     */
    public PsiStorage selectPsiStorageById(Long id);

    /**
     * 查询入库单列表
     * 
     * @param psiStorage 入库单
     * @return 入库单集合
     */
    public List<PsiStorage> selectPsiStorageList(StorageVO psiStorage);

    /**
     * 新增入库单
     * 
     * @param supplyVO 入库单
     * @return 结果
     */
    public int insertPsiStorage(SupplyVO supplyVO);

    /**
     * 修改入库单
     * 
     * @param psiStorage 入库单
     * @return 结果
     */
    public int updatePsiStorage(PsiStorage psiStorage);

    /**
     * 批量删除入库单
     * 
     * @param ids 需要删除的入库单主键集合
     * @return 结果
     */
    public int deletePsiStorageByIds(Long[] ids);

    /**
     * 删除入库单信息
     * 
     * @param id 入库单主键
     * @return 结果
     */
    public int deletePsiStorageById(Long id);

    /**
     * 入库汇总
     * @param param
     * @return
     */
    Map storageList(Map<String,Object> param);

    /**
     * 新增汇总信息
     * @param param
     * @return
     */
    int addSummary(Map<String, Object> param);

    /**
     * 出库*
     * @param psiStorage
     * @return
     */
    int outbound(PsiStorage psiStorage);

    /**
     * 导出入库单详情*
     * @param psiSrorageItem
     * @return
     */
    List<StorageItemExportVO> exportStorageItem(PsiSrorageItem psiSrorageItem);

    /**
     * 获得入库单详情 根据id集合*
     * @param ids
     * @return
     */
    List<PsiSrorageItem> getInfoByIds(List<Long> ids);

    /**
     *  汇总报表，目录下入库明细
     */
    List<PsiSrorageItem> listAll(StorageVO psiStorage);

    /**
     * 汇总报表，目录下入库明细 导出
     * @param psiStorage
     * @return
     */
    List<PsiSrorageItemVO> exportQueryListAll(StorageVO psiStorage);

    List<StorageVO> selectPsiStorageVoList(StorageVO psiStorage);

    int revokeStorage(Long id);

    /**
     * 获得列表总金额
     * @param psiStorage
     * @return
     */
    Map<String, Object> getTotalAmount(StorageVO psiStorage);

    List<StorageItemExportVO> exportStorageItems(PsiSrorageItem psiSrorageItem);

    /**
     * 库存数量列表
     * @param storageNumberVO
     * @return
     */
    List<StorageNumberVO> listInventoryQuantity(StorageNumberVO storageNumberVO);
}
