package com.ruoyi.psi.service;

import java.util.List;
import com.ruoyi.psi.domain.PsiStore;

/**
 * 仓库Service接口
 * 
 * @author ruoyi
 * @date 2024-01-03
 */
public interface IPsiStoreService 
{
    /**
     * 查询仓库
     * 
     * @param storeId 仓库主键
     * @return 仓库
     */
    public PsiStore selectPsiStoreByStoreId(Long storeId);

    /**
     * 查询仓库列表
     * 
     * @param psiStore 仓库
     * @return 仓库集合
     */
    public List<PsiStore> selectPsiStoreList(PsiStore psiStore);

    /**
     * 新增仓库
     * 
     * @param psiStore 仓库
     * @return 结果
     */
    public int insertPsiStore(PsiStore psiStore);

    /**
     * 修改仓库
     * 
     * @param psiStore 仓库
     * @return 结果
     */
    public int updatePsiStore(PsiStore psiStore);

    /**
     * 批量删除仓库
     * 
     * @param storeIds 需要删除的仓库主键集合
     * @return 结果
     */
    public int deletePsiStoreByStoreIds(Long[] storeIds);

    /**
     * 删除仓库信息
     * 
     * @param storeId 仓库主键
     * @return 结果
     */
    public int deletePsiStoreByStoreId(Long storeId);
}
