package com.ruoyi.psi.service;

import java.util.List;
import java.util.Map;

import com.ruoyi.psi.domain.PsiSupply;
import com.ruoyi.psi.domain.PsiSupplyItem;
import com.ruoyi.psi.domain.vo.CalculateGoodsReq;
import com.ruoyi.psi.domain.vo.SupplyVO;

/**
 * 供货单Service接口
 * 
 * @author ruoyi
 * @date 2023-12-14
 */
public interface IPsiSupplyService 
{
    /**
     * 查询供货单
     * 
     * @param id 供货单主键
     * @return 供货单
     */
    public SupplyVO selectPsiSupplyById(Long id,Long tenantId);

    /**
     *  (已入库数量 != 实际数量)
     * @param id
     * @param tenantId
     * @return
     */
    public SupplyVO selectPsiSupplyByIdTwo(Long id,Long tenantId);

    public List<PsiSupplyItem> calculateGoods(CalculateGoodsReq calVo, Long tenantId);

    /**
     * 查询供货单列表
     * 
     * @param psiSupply 供货单
     * @return 供货单集合
     */
    public List<PsiSupply> selectPsiSupplyList(PsiSupply psiSupply);

    /**
     * 新增供货单
     * 
     * @param psiSupply 供货单
     * @return 结果
     */
    public int insertPsiSupply(PsiSupply psiSupply);

    /**
     * 修改供货单
     * 
     * @param psiSupply 供货单
     * @return 结果
     */
    public int updatePsiSupply(PsiSupply psiSupply);

    /**
     * 批量删除供货单
     * 
     * @param ids 需要删除的供货单主键集合
     * @return 结果
     */
    public int deletePsiSupplyByIds(Long[] ids);

    /**
     * 删除供货单信息
     * 
     * @param id 供货单主键
     * @return 结果
     */
    public int deletePsiSupplyById(Long id);

    /**
     *
     * 根据采购单id获得供货单
     * @param purchaseId
     * @param tenantId
     * @return
     */
    SupplyVO getSupplyByPurchaseId(Long purchaseId, Long tenantId, Long supplierId);



    /**
     * @description
     *
     * @param supplyVO
     * @return int
     * @author fm
     * @date 2023/12/15 10:13
     */
    int addSupply(SupplyVO supplyVO);

    int revokeSupply(Long id);
}
