package com.ruoyi.psi.service;


import com.ruoyi.psi.domain.PsiSupply;
import com.ruoyi.psi.domain.PsiSupplyItem;
import com.ruoyi.psi.domain.vo.ReceiptExportVO;
import com.ruoyi.psi.domain.vo.SupplyVO;

import java.util.List;
import java.util.Map;

public interface PsiReceiptService {

    // 收货
    int addReceipt(SupplyVO supplyVO);

    // 已收货订单
    List<PsiSupply> selectList(PsiSupply psiSupply);

    SupplyVO selectPsiSupplyById(Long id, Long tenantId);

    // 手动收货
    int manuallyReceipt(SupplyVO supplyVO);

    // 已收货订单 不分页
    List<PsiSupply> listAll(PsiSupply psiSupply);

    // 更改已确认收货订单的状态
    int updateReceiptStatus(PsiSupply supply);

    // 更新暂存的数据
    int updateReceipt(SupplyVO supplyVO);

    int revokeReceipt(Long id);

    // 收货总金额
    Map<String, Object> getTotalAmount(PsiSupply psiSupply);

    // 导出收货单详情
    List<ReceiptExportVO> exportItem(PsiSupply psiSupply);
}
