package com.ruoyi.psi.service.impl;

import java.util.List;
import java.util.Map;

import com.ruoyi.common.constant.ApprovalConstants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.psi.domain.ApprovalRecording;
import com.ruoyi.psi.domain.PsiSummaryItem;
import com.ruoyi.psi.domain.vo.SummaryVO;
import com.ruoyi.psi.mapper.ApprovalRecordingMapper;
import com.ruoyi.psi.mapper.PsiSummaryItemMapper;
import com.ruoyi.psi.util.CommonUtil;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.psi.mapper.PsiSummaryMapper;
import com.ruoyi.psi.domain.PsiSummary;
import com.ruoyi.psi.service.IPsiSummaryService;
import org.springframework.transaction.annotation.Transactional;

/**
 * 【请填写功能名称】Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-12-25
 */
@Service
public class PsiSummaryServiceImpl implements IPsiSummaryService 
{
    @Autowired
    private PsiSummaryMapper psiSummaryMapper;

    @Autowired
    private PsiSummaryItemMapper summaryItemMapper;

    @Autowired
    private CommonUtil commonUtil;

    @Autowired
    private ApprovalRecordingMapper approvalRecordingMapper;

    /**
     * 查询【请填写功能名称】
     * 
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public SummaryVO selectPsiSummaryById(Long id, Integer type)
    {
        SummaryVO vo = new SummaryVO();
        PsiSummary summary = psiSummaryMapper.selectPsiSummaryById(id);
        BeanUtils.copyProperties(summary,vo);
        List<PsiSummaryItem> list = summaryItemMapper.selectSummaryItemBySummaryId(id);
        vo.setSummaryItems(list);

        // 查询流程详细
        ApprovalRecording approvalRecording = new ApprovalRecording();
        approvalRecording.setDocumentId(id);
        approvalRecording.setDocumentType(ApprovalConstants.RUKUHUIZONG);
        approvalRecording.setzTenantId(summary.getTenantId());
        List<ApprovalRecording> inApprovalRecordingList = commonUtil.getRecordingList(approvalRecording);
        approvalRecording.setDocumentType(ApprovalConstants.CHUKUHUIZONG);
        List<ApprovalRecording> outApprovalRecordingList = commonUtil.getRecordingList(approvalRecording);
        vo.setInApprovalRecordingList(inApprovalRecordingList);
        vo.setOutApprovalRecordingList(outApprovalRecordingList);
        return vo;
    }

    /**
     * 查询【请填写功能名称】列表
     * 
     * @param psiSummary 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<PsiSummary> selectPsiSummaryList(PsiSummary psiSummary)
    {
        return psiSummaryMapper.selectPsiSummaryList(psiSummary);
    }

    /**
     * 新增【请填写功能名称】
     * 
     * @param psiSummary 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertPsiSummary(PsiSummary psiSummary)
    {
        psiSummary.setCreateTime(DateUtils.getNowDate());
        return psiSummaryMapper.insertPsiSummary(psiSummary);
    }

    /**
     * 修改【请填写功能名称】
     * 
     * @param psiSummary 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updatePsiSummary(PsiSummary psiSummary)
    {
        return psiSummaryMapper.updatePsiSummary(psiSummary);
    }

    /**
     * 批量删除【请填写功能名称】
     * 
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deletePsiSummaryByIds(Long[] ids)
    {
        return psiSummaryMapper.deletePsiSummaryByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     * 
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deletePsiSummaryById(Long id)
    {
        return psiSummaryMapper.deletePsiSummaryById(id);
    }

    /**
     * 更改入库汇总状态*
     * @param id
     * @return
     */
    @Override
    public int updateType(Long id) {
        PsiSummary summary1 = psiSummaryMapper.selectPsiSummaryById(id);
        PsiSummary summary = new PsiSummary();
        summary.setId(id);
        summary.setType(2);
        summary.setTimePeriodStart(summary1.getTimePeriodStart());
        summary.setTimePeriodEnd(summary1.getTimePeriodEnd());
        psiSummaryMapper.updatePsiSummary(summary);
        return 1;
    }

    /**
     *
     * @param id
     * @return
     */
    @Override
    @Transactional
    public int revokeSummary(Long id, Integer type){
        PsiSummary summary1 = psiSummaryMapper.selectPsiSummaryById(id);

        // 入库汇总撤回，需要校验是否已出库汇总  type 1:入库 2:出库 3审核中  4 出库审核中   5 出库审核完成
        if(type == 1 && (summary1.getType() == 2 || summary1.getType() == 4 || summary1.getType() == 5)){
            throw new ServiceException("已出库汇总，请先撤回出库汇总表!");
        }
        if(type == 1){
            summaryItemMapper.deletePsiSummaryItemBySummaryId(id);
            psiSummaryMapper.deletePsiSummaryById(id);
            // 清除中间表数据
            psiSummaryMapper.deletePsiSummaryStorageRef(id);
            // 删除审批记录

            ApprovalRecording approvalRecording = new ApprovalRecording();
            approvalRecording.setTenantId(summary1.getTenantId());
            approvalRecording.setDocumentId(id);
            approvalRecording.setDocumentType(8);
            commonUtil.edit(approvalRecording);
        } else if(type == 2){
            PsiSummary summary = new PsiSummary();
            summary.setId(id);
            summary.setType(1);
            psiSummaryMapper.updatePsiSummary(summary);

            // 删除审批记录
            ApprovalRecording approvalRecording = new ApprovalRecording();
            approvalRecording.setTenantId(summary1.getTenantId());
            approvalRecording.setDocumentId(id);
            approvalRecording.setDocumentType(9);
            commonUtil.edit(approvalRecording);

            approvalRecording.setDocumentType(8);
            commonUtil.edit(approvalRecording);
        }
        // 删除审批记录
        // ApprovalRecording approvalRecording = new ApprovalRecording();
        // approvalRecording.setTenantId(summary1.getTenantId());
        // approvalRecording.setDocumentId(id);
        // approvalRecording.setDocumentType(9);
        // commonUtil.edit(approvalRecording);
        return 1;
    }

    /**
     * 获得入库汇总总金额
     * @param psiSummary
     * @return
     */
    @Override
    public Map<String, Object> getTotalAmount(PsiSummary psiSummary) {
        return psiSummaryMapper.getTotalAmount(psiSummary);
    }
}
