package com.ruoyi.psi.util;

import com.ruoyi.psi.domain.ApprovalRecording;
import com.ruoyi.psi.mapper.ApprovalRecordingMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * @ClassName CommonUtil
 * @Description
 * @Author fm
 * @Date 2024/1/22 10:02
 * @Version V1.0
 */
@Component
public class CommonUtil {

    @Autowired
    private ApprovalRecordingMapper approvalRecordingMapper;

    /**
     * 删除流程
     * @param approvalRecording
     */
    public void edit(ApprovalRecording approvalRecording){
        List<ApprovalRecording> approvalRecordingList = approvalRecordingMapper.selectApprovalRecordingById(approvalRecording);
        if(!CollectionUtils.isEmpty(approvalRecordingList)){
            // 删除审批记录表记录,重新走流程
            approvalRecordingMapper.deleteApprovalRecordingByDocumentIdAndTenantId(approvalRecording.getDocumentId(),
                    approvalRecording.getTenantId(), approvalRecording.getDocumentType());
        }
    }

    /**
     * 获得流程详细
     * @param approvalRecording
     * @return
     */
    public List<ApprovalRecording> getRecordingList(ApprovalRecording approvalRecording) {
        List<ApprovalRecording> approvalRecordingList = approvalRecordingMapper.selectApprovalRecordingListByDocument(approvalRecording);
        return approvalRecordingList;
    }
}