package com.ruoyi.psi.util;

import com.ruoyi.psi.domain.PsiSummaryItem;
import com.ruoyi.psi.domain.vo.SummaryVO;
import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.*;

import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * @ClassName EUtil
 * @Description
 * @Author fm
 * @Date 2024/1/5 15:09
 * @Version V1.0
 */
public class EUtil {
    public void exportData(String msg, SummaryVO vo, HttpServletResponse response) {
        try {
            List<PsiSummaryItem> summaryItems = vo.getSummaryItems();
            XSSFWorkbook wb = new XSSFWorkbook();
            XSSFRow row = null;
            XSSFCell cell = null;
            // 建立新的sheet对象（excel的表单） 并设置sheet名字
            XSSFSheet sheet = wb.createSheet("统计报表");
            sheet.setDefaultRowHeightInPoints(20);
            sheet.setDefaultColumnWidth(12);
            //----------------标题样式--------------------------------
            XSSFCellStyle titleStyle = wb.createCellStyle(); //标题样式
            titleStyle.setAlignment(HorizontalAlignment.CENTER);
            titleStyle.setVerticalAlignment(VerticalAlignment.CENTER);
            Font ztFont = wb.createFont();
            ztFont.setItalic(false); // 设置字体为斜体字
            ztFont.setFontHeightInPoints((short) 16); // 将字体大小设置为18px
            ztFont.setFontName("宋体"); // 将“宋体”字体应用到当前单元格上
            ztFont.setBold(true); //加粗
            titleStyle.setFont(ztFont);
            //------------------------------------------------------------
            //----------------二级标题格样式----------------------------------
            XSSFCellStyle titleStyle2 = wb.createCellStyle(); //表格样式
            titleStyle2.setAlignment(HorizontalAlignment.CENTER);
            titleStyle2.setVerticalAlignment(VerticalAlignment.CENTER);

            titleStyle2.setBorderBottom(BorderStyle.THIN);//下边框
            titleStyle2.setBorderLeft(BorderStyle.THIN);//左边框
            titleStyle2.setBorderRight(BorderStyle.THIN);//右边框
            titleStyle2.setBorderTop(BorderStyle.THIN);//上边框

            Font ztFont2 = wb.createFont();
            ztFont2.setItalic(false); // 设置字体为斜体字
            ztFont2.setColor(Font.COLOR_NORMAL); // 将字体设置为“红色”
            ztFont2.setFontHeightInPoints((short) 10); // 将字体大小设置为18px
            ztFont2.setFontName("宋体"); // 字体应用到当前单元格上
            ztFont2.setBold(true); //加粗
            titleStyle2.setFont(ztFont2);
            titleStyle2.setWrapText(true);//设置自动换行
            //----------------------------------------------------------
            //----------------单元格样式-----------------------------------
            XSSFCellStyle cellStyle = wb.createCellStyle(); //表格样式
            cellStyle.setAlignment(HorizontalAlignment.CENTER);
            cellStyle.setVerticalAlignment(VerticalAlignment.CENTER);

            cellStyle.setBorderBottom(BorderStyle.THIN);//下边框
            cellStyle.setBorderLeft(BorderStyle.THIN);//左边框
            cellStyle.setBorderRight(BorderStyle.THIN);//右边框
            cellStyle.setBorderTop(BorderStyle.THIN);//上边框

            Font cellFont = wb.createFont();
            cellFont.setItalic(false); // 设置字体为斜体字
            cellFont.setColor(Font.COLOR_NORMAL); // 将字体设置为“红色”
            cellFont.setFontHeightInPoints((short) 9); // 将字体大小设置为18px
            cellFont.setFontName("宋体"); // 字体应用到当前单元格上
            cellStyle.setFont(cellFont);
            cellStyle.setWrapText(true);//设置自动换行

            //----------------数字单元格格式-----------------------------------
            XSSFCellStyle cellStyleNum = wb.createCellStyle(); //表格样式
            cellStyleNum.setAlignment(HorizontalAlignment.CENTER);
            cellStyleNum.setVerticalAlignment(VerticalAlignment.CENTER);

            cellStyleNum.setBorderBottom(BorderStyle.THIN);//下边框
            cellStyleNum.setBorderLeft(BorderStyle.THIN);//左边框
            cellStyleNum.setBorderRight(BorderStyle.THIN);//右边框
            cellStyleNum.setBorderTop(BorderStyle.THIN);//上边框

            Font cellFontNum = wb.createFont();
            cellFontNum.setItalic(false); // 设置字体为斜体字
            cellFontNum.setColor(Font.COLOR_NORMAL); // 将字体设置为“红色”
            cellFontNum.setFontHeightInPoints((short) 9); // 将字体大小设置为18px
            cellFontNum.setFontName("宋体"); // 字体应用到当前单元格上
            cellStyleNum.setFont(cellFontNum);
            cellStyleNum.setWrapText(true);//设置自动换行
            //----------------------------------------------------------

            // ----------------------创建第一行----------------------------
            // 在sheet里创建第一行，参数为行索引(excel的行)，可以是0～65535之间的任何一个
            row = sheet.createRow(0);
            // 创建单元格（excel的单元格，参数为列索引，可以是0～255之间的任何一个
            cell = row.createCell(0);
            // 合并单元格CellRangeAddress构造参数依次表示起始行，截至行，起始列， 截至列
            sheet.addMergedRegion(new CellRangeAddress(0, 0, 0, 8));
            // 设置单元格内容
            cell.setCellValue(msg);
            cell.setCellStyle(titleStyle);

            XSSFRow row1 = sheet.createRow(1);
            XSSFCell cell1 = row1.createCell(0);
            cell1.setCellValue("仓库名称:");
            String storeName = vo.getStoreName();
            XSSFCell cell6 = row1.createCell(1);
            cell6.setCellValue(storeName);

            XSSFCell cell2 = row1.createCell(6);
            cell2.setCellValue("业务日期:");
            Date timePeriodStart = vo.getTimePeriodStart();
            Date timePeriodEnd = vo.getTimePeriodEnd();
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
            String s = dateFormat.format(timePeriodStart);
            String e = dateFormat.format(timePeriodEnd);
            XSSFCell cell7 = row1.createCell(7);
            cell7.setCellValue(s + "-" + e);

            XSSFRow row2 = sheet.createRow(2);
            XSSFCell cell3 = row2.createCell(0);
            cell3.setCellValue("供应商:");
            XSSFCell cell8 = row2.createCell(1);
            String supplierName = vo.getSupplierName();
            cell8.setCellValue(supplierName);

            XSSFCell cell4 = row2.createCell(6);
            cell4.setCellValue("单据编号:");
            XSSFCell cell26 = row2.createCell(7);
            XSSFCellStyle cellStylex = wb.createCellStyle();
            cellStylex.setAlignment(HorizontalAlignment.LEFT);
            cell26.setCellValue(vo.getId());
            cell26.setCellStyle(cellStylex);

            XSSFRow row3 = sheet.createRow(3);
            XSSFCell cell5 = row3.createCell(0);
            cell5.setCellValue("摘要:");
            XSSFCell cell9 = row3.createCell(1);
            String remark = vo.getRemark();
            cell9.setCellValue(remark);

            XSSFRow row4 = sheet.createRow(4);
            XSSFCell cell10 = row4.createCell(0);
            cell10.setCellValue("行号");
            cell10.setCellStyle(titleStyle2);
            XSSFCell cell11 = row4.createCell(1);
            cell11.setCellValue("物资编码");
            cell11.setCellStyle(titleStyle2);
            XSSFCell cell12 = row4.createCell(2);
            cell12.setCellValue("物资名称");
            cell12.setCellStyle(titleStyle2);
            XSSFCell cell13 = row4.createCell(3);
            cell13.setCellValue("规格型号");
            cell13.setCellStyle(titleStyle2);
            XSSFCell cell14 = row4.createCell(4);
            cell14.setCellValue("单位");
            cell14.setCellStyle(titleStyle2);
            XSSFCell cell15 = row4.createCell(5);
            cell15.setCellValue("数量");
            cell15.setCellStyle(titleStyle2);
            XSSFCell cell16 = row4.createCell(6);
            cell16.setCellValue("价格");
            cell16.setCellStyle(titleStyle2);
            XSSFCell cell17 = row4.createCell(7);
            cell17.setCellValue("金额");
            cell17.setCellStyle(titleStyle2);

            int rowNum = 5;
            int line = 1;

            int size = 0;
            BigDecimal quantityTotal = new BigDecimal("0");
            if (summaryItems != null) {
                for (int i = 0; i < summaryItems.size(); i++) {
                    PsiSummaryItem summaryItem = summaryItems.get(i);
                    XSSFRow rowi = sheet.createRow(rowNum);
                    XSSFCell cell18 = rowi.createCell(0);
                    cell18.setCellStyle(cellStyle);
                    cell18.setCellValue(line);

                    XSSFCell cell19 = rowi.createCell(1);
                    cell19.setCellStyle(cellStyle);
                    cell19.setCellValue(summaryItem.getId());

                    XSSFCell cell20 = rowi.createCell(2);
                    cell20.setCellStyle(cellStyle);
                    cell20.setCellValue(summaryItem.getGoodsName());

                    XSSFCell cell21 = rowi.createCell(3);
                    cell21.setCellStyle(cellStyle);
                    cell21.setCellValue(summaryItem.getSpec());

                    XSSFCell cell22 = rowi.createCell(4);
                    cell22.setCellStyle(cellStyle);
                    cell22.setCellValue(summaryItem.getUnit());

                    XSSFCell cell23 = rowi.createCell(5);
                    cell23.setCellStyle(cellStyle);
                    BigDecimal thisQuantity = summaryItem.getThisQuantity();
                    cell23.setCellValue(thisQuantity.doubleValue());
                    quantityTotal = quantityTotal.add(thisQuantity);

                    XSSFCell cell24 = rowi.createCell(6);
                    cell24.setCellStyle(cellStyle);
                    cell24.setCellValue(summaryItem.getPriceInput().doubleValue());

                    XSSFCell cell25 = rowi.createCell(7);
                    cell25.setCellStyle(cellStyle);
                    cell25.setCellValue(summaryItem.getGoodsAmount().doubleValue());

                    line++;
                    rowNum++;
                }
                size = summaryItems.size();
            }
            // 最后一行
            XSSFRow row5 = sheet.createRow(5 + size);
            XSSFCell cell18 = row5.createCell(0);
            cell18.setCellStyle(cellStyle);
            cell18.setCellValue("合计:");

            XSSFCell cell20 = row5.createCell(5);
            cell20.setCellStyle(cellStyle);
            cell20.setCellValue(quantityTotal.doubleValue());

            XSSFCell cell19 = row5.createCell(7);
            cell19.setCellStyle(cellStyle);
            cell19.setCellValue(vo.getTotalAmount().doubleValue());



            response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
            response.setCharacterEncoding("utf-8");
            wb.write(response.getOutputStream());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


}