package com.ruoyi.sup.controller;

import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.sup.domain.PsiBidding;
import com.ruoyi.sup.domain.vo.BiddingVO;
import com.ruoyi.sup.service.IPsiBiddingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 竞价单Controller
 * 
 * @author ruoyi
 * @date 2023-12-17
 */
@RestController
@RequestMapping("/sup/bidding")
public class PsiBiddingController extends BaseController
{
    @Autowired
    private IPsiBiddingService psiBiddingService;

    /**
     * 新增竞价单
     */
    // @PreAuthorize("@ss.hasPermi('sup:bidding:add')")
    // @Log(title = "竞价单", businessType = BusinessType.INSERT)
    // @PostMapping
    // public AjaxResult add(@RequestBody PsiBidding psiBidding)
    // {
    //     return toAjax(psiBiddingService.insertPsiBidding(psiBidding));
    // }

    /**
     * 修改竞价单
     */
    // @PreAuthorize("@ss.hasPermi('sup:bidding:edit')")
    // @Log(title = "竞价单", businessType = BusinessType.UPDATE)
    // @PutMapping
    // public AjaxResult edit(@RequestBody PsiBidding psiBidding)
    // {
    //     return toAjax(psiBiddingService.updatePsiBidding(psiBidding));
    // }


    /**
     * 删除竞价单
     */
    // @PreAuthorize("@ss.hasPermi('sup:bidding:remove')")
    // @Log(title = "竞价单", businessType = BusinessType.DELETE)
    // @DeleteMapping("/{ids}")
    // public AjaxResult remove(@PathVariable Long[] ids)
    // {
    //     return toAjax(psiBiddingService.deletePsiBiddingByIds(ids));
    // }

    /**
     * 查询竞价单列表
     */
    @PreAuthorize("@ss.hasPermi('sup:bidding:list')")
    @GetMapping("/list")
    public TableDataInfo list(PsiBidding psiBidding)
    {
        // 获取当前登录用户所属租户ID
        Long tenantId = this.getTenantId();
        psiBidding.setSupplierId(tenantId);
        startPage();
        List<PsiBidding> list = psiBiddingService.selectPsiBiddingList(psiBidding);
        return getDataTable(list);
    }

    /**
     * 导出竞价单列表
     */
    // @PreAuthorize("@ss.hasPermi('sup:bidding:export')")
    // @Log(title = "竞价单", businessType = BusinessType.EXPORT)
    // @PostMapping("/export")
    // public void export(HttpServletResponse response, PsiBidding psiBidding)
    // {
    //     List<PsiBidding> list = psiBiddingService.selectPsiBiddingList(psiBidding);
    //     ExcelUtil<PsiBidding> util = new ExcelUtil<PsiBidding>(PsiBidding.class);
    //     util.exportExcel(response, list, "竞价单数据");
    // }

    /**
     *  根据采购单生成竞价单
     * @param purchaseId
     * @return
     */
    @Log(title = "竞价单", businessType = BusinessType.INSERT)
    // @PreAuthorize("@ss.hasPermi('sup:bidding:add')")
    @PostMapping("/addBidding/{purchaseId}")
    public AjaxResult addBidding(@PathVariable Long purchaseId)
    {
        // 获取当前登录用户所属租户ID
        Long tenantId = this.getTenantId();
        return toAjax(psiBiddingService.addBidding(purchaseId,tenantId));
    }

    // 获得竞价单详情
    @PreAuthorize("@ss.hasPermi('sup:bidding:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        // 获取当前登录用户所属租户ID
        Long supplierId = this.getTenantId();
        return success(psiBiddingService.selectBiddingDetailById(id,supplierId));
    }

    // 竞价单供应商报价(每个商品进行报价)
    @PreAuthorize("@ss.hasPermi('sup:bidding:add')")
    @Log(title = "竞价单", businessType = BusinessType.INSERT)
    @PostMapping("/biddingQuote")
    public AjaxResult biddingQuote(@RequestBody BiddingVO vo)
    {
        return toAjax(psiBiddingService.biddingQuote(vo));
    }


    // 竞价单提交(供应商提交)    找出最低价格的插入到供货单
    @PreAuthorize("@ss.hasPermi('sup:bidding:edit')")
    @Log(title = "竞价单", businessType = BusinessType.UPDATE)
    @PostMapping("/updateStatus/{biddingId}")
    public AjaxResult edit(@PathVariable Long biddingId)
    {
        return toAjax(psiBiddingService.edit(biddingId));
    }

}
