package com.ruoyi.sup.controller;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.sup.service.ISupApprovalRecordingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @ClassName SupApprovalRecordingController
 * @Description
 * @Author fm
 * @Date 2024/1/31 11:08
 * @Version V1.0
 */
@RestController
@RequestMapping("/sup/recording")
public class SupApprovalRecordingController {

    @Autowired
    private ISupApprovalRecordingService supApprovalRecordingService;

    /**
     * 查看单据详情(供应商)
     * @return
     */
    @PreAuthorize("@ss.hasPermi('sup:sRecording:query')")
    @GetMapping(value = "/supGetRecordingInfo/{documentId}/{documentType}")
    public AjaxResult supGetRecordingInfo(@PathVariable("documentId") Long documentId,
                              @PathVariable("documentType") Integer documentType){
        return supApprovalRecordingService.getInfo(documentId,documentType);
    }

}