package com.ruoyi.sup.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.psi.domain.PsiStorage;
import com.ruoyi.psi.service.IPsiStorageService;
import com.ruoyi.sup.domain.SupStorage;
import com.ruoyi.sup.service.SupStorageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @ClassName SupStorageController
 * @Description
 * @Author fm
 * @Date 2023/12/28 9:19
 * @Version V1.0
 */
@RestController
@RequestMapping("/sup/storage")
public class SupStorageController extends BaseController {

    @Autowired
    private SupStorageService storageService;
    @Autowired
    private IPsiStorageService psiStorageService;

    /**
     *
     * @param storage
     * @return
     */
    // @PreAuthorize("@ss.hasPermi('sup:storage:list')")
    @GetMapping("/list")
    public TableDataInfo list(SupStorage storage)
    {
        Long tenantId = this.getTenantId();
        storage.setSupplierId(tenantId);
        startPage();
        List<SupStorage> list = storageService.selectSupStorageList(storage);
        return getDataTable(list);
    }

     /**
     * 获得入库单详情
     */
    // @PreAuthorize("@ss.hasPermi('psi:storage:query')")
    @GetMapping(value = "/getInfoByIds/{id}")
    public AjaxResult getInfoById(@PathVariable Long id)
    {
        return success(psiStorageService.selectPsiStorageById(id));
    }

    /**
     * 销货单 撤回
     */
    @PreAuthorize("@ss.hasPermi('sup:storage:revoke')")
    @GetMapping(value = "/revokeStorage/{id}")
    public AjaxResult revokeStorage(@PathVariable("id") Long id)
    {
        return toAjax(storageService.revokeStorage(id));
    }

}