package com.ruoyi.sup.domain;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 入库单对象 psi_storage
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
public class SupStorage extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 收货单id */
    @Excel(name = "收货单id")
    private Long supplyId;

    /** 供应商id */
    @Excel(name = "供应商id")
    private Long supplierId;

    /** 供应商名称 */
    @Excel(name = "供应商名称")
    private String supplierName;

    /** 入库人 */
    @Excel(name = "入库人")
    private Long createUser;

    /** 入库人姓名 */
    @Excel(name = "入库人姓名")
    private String createUserName;

    /** 租户id */
    @Excel(name = "租户id")
    private Long tenantId;

    /** 租户姓名 */
    @Excel(name = "租户姓名")
    private String tenantName;


    /** 本次入库金额 */
    @Excel(name = "本次入库金额")
    private BigDecimal amount;

    /** 审核 */
    @Excel(name = "审核")
    private Integer audit;

    /** 审核时间(出库时间) */
    private Date auditTime;

    /** 状态 0:未出库 1:已出库 */
    private Integer status;

    /** 销货单审核状态 1:已审核 0:未审核 2:审核中 */
    private Integer salesAuditStatus;

    public SupStorage() {
    }

    public SupStorage(Long id, Long supplyId, Long supplierId, String supplierName, Long createUser, String createUserName, Long tenantId, String tenantName, BigDecimal amount, Integer audit, Date auditTime, Integer status, Integer salesAuditStatus) {
        this.id = id;
        this.supplyId = supplyId;
        this.supplierId = supplierId;
        this.supplierName = supplierName;
        this.createUser = createUser;
        this.createUserName = createUserName;
        this.tenantId = tenantId;
        this.tenantName = tenantName;
        this.amount = amount;
        this.audit = audit;
        this.auditTime = auditTime;
        this.status = status;
        this.salesAuditStatus = salesAuditStatus;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getSupplyId() {
        return supplyId;
    }

    public void setSupplyId(Long supplyId) {
        this.supplyId = supplyId;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public Integer getAudit() {
        return audit;
    }

    public void setAudit(Integer audit) {
        this.audit = audit;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getSalesAuditStatus() {
        return salesAuditStatus;
    }

    public void setSalesAuditStatus(Integer salesAuditStatus) {
        this.salesAuditStatus = salesAuditStatus;
    }

    @Override
    public String toString() {
        return "SupStorage{" +
                "id=" + id +
                ", supplyId=" + supplyId +
                ", supplierId=" + supplierId +
                ", supplierName='" + supplierName + '\'' +
                ", createUser=" + createUser +
                ", createUserName='" + createUserName + '\'' +
                ", tenantId=" + tenantId +
                ", tenantName='" + tenantName + '\'' +
                ", amount=" + amount +
                ", audit=" + audit +
                ", auditTime=" + auditTime +
                ", status=" + status +
                ", salesAuditStatus=" + salesAuditStatus +
                '}';
    }
}
