package com.ruoyi.sup.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

/**
 * 供货单对象 psi_supply
 * 
 * @author ruoyi
 * @date 2023-12-19
 */
public class SupSupply extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 创建人 */
    // @Excel(name = "创建人")
    private Long createUser;

    /** 供应商id */
    // @Excel(name = "供应商id")
    private Long supplierId;

    /** 采购单id */
    // @Excel(name = "采购单id")
    private Long purchaseId;

    /** 租户id */
    // @Excel(name = "租户id")
    private Long tenantId;

    /** 总金额 */
    @Excel(name = "总金额")
    private BigDecimal totalAmount;

    @Excel(name = "供应商名称")
    private String supplierName;

    /**备注 */
    @Excel(name = "备注")
    private String remark;

    /**状态 1:收货 0:未收货 */
    @Excel(name = "状态",readConverterExp = "0=未收货,1=已收货")
    private Integer status;

    private String createUsername;

    @Excel(name = "下单人姓名")
    private String tenantName;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date businessTime;

    public SupSupply() {
    }

    public SupSupply(Long id, Long createUser, Long supplierId, Long purchaseId, Long tenantId, BigDecimal totalAmount, String supplierName, String remark, Integer status, String createUsername, String tenantName, Date businessTime) {
        this.id = id;
        this.createUser = createUser;
        this.supplierId = supplierId;
        this.purchaseId = purchaseId;
        this.tenantId = tenantId;
        this.totalAmount = totalAmount;
        this.supplierName = supplierName;
        this.remark = remark;
        this.status = status;
        this.createUsername = createUsername;
        this.tenantName = tenantName;
        this.businessTime = businessTime;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getCreateUser() {
        return createUser;
    }

    public void setCreateUser(Long createUser) {
        this.createUser = createUser;
    }

    public Long getSupplierId() {
        return supplierId;
    }

    public void setSupplierId(Long supplierId) {
        this.supplierId = supplierId;
    }

    public Long getPurchaseId() {
        return purchaseId;
    }

    public void setPurchaseId(Long purchaseId) {
        this.purchaseId = purchaseId;
    }

    public Long getTenantId() {
        return tenantId;
    }

    public void setTenantId(Long tenantId) {
        this.tenantId = tenantId;
    }

    public BigDecimal getTotalAmount() {
        return totalAmount;
    }

    public void setTotalAmount(BigDecimal totalAmount) {
        this.totalAmount = totalAmount;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    @Override
    public String getRemark() {
        return remark;
    }

    @Override
    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getCreateUsername() {
        return createUsername;
    }

    public void setCreateUsername(String createUsername) {
        this.createUsername = createUsername;
    }

    public String getTenantName() {
        return tenantName;
    }

    public void setTenantName(String tenantName) {
        this.tenantName = tenantName;
    }

    public Date getBusinessTime() {
        return businessTime;
    }

    public void setBusinessTime(Date businessTime) {
        this.businessTime = businessTime;
    }

    @Override
    public String toString() {
        return "SupSupply{" +
                "id=" + id +
                ", createUser=" + createUser +
                ", supplierId=" + supplierId +
                ", purchaseId=" + purchaseId +
                ", tenantId=" + tenantId +
                ", totalAmount=" + totalAmount +
                ", supplierName='" + supplierName + '\'' +
                ", remark='" + remark + '\'' +
                ", status=" + status +
                ", createUsername='" + createUsername + '\'' +
                ", tenantName='" + tenantName + '\'' +
                ", businessTime=" + businessTime +
                '}';
    }
}
