package com.ruoyi.sup.mapper;

import java.util.List;
import com.ruoyi.sup.domain.PsiBiddingItem;
import org.apache.ibatis.annotations.Param;

/**
 * 竞价单详情Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-18
 */
public interface PsiBiddingItemMapper 
{
    /**
     * 查询竞价单详情
     * 
     * @param id 竞价单详情主键
     * @return 竞价单详情
     */
    public List<PsiBiddingItem> selectPsiBiddingItemById(Long id);

    /**
     * 查询竞价单详情列表
     * 
     * @param psiBiddingItem 竞价单详情
     * @return 竞价单详情集合
     */
    public List<PsiBiddingItem> selectPsiBiddingItemList(PsiBiddingItem psiBiddingItem);

    /**
     * 新增竞价单详情
     * 
     * @param psiBiddingItem 竞价单详情
     * @return 结果
     */
    public int insertPsiBiddingItem(PsiBiddingItem psiBiddingItem);

    /**
     * 修改竞价单详情
     * 
     * @param psiBiddingItem 竞价单详情
     * @return 结果
     */
    public int updatePsiBiddingItem(PsiBiddingItem psiBiddingItem);

    /**
     * 删除竞价单详情
     * 
     * @param id 竞价单详情主键
     * @return 结果
     */
    public int deletePsiBiddingItemById(Long id);

    /**
     * 批量删除竞价单详情
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiBiddingItemByIds(Long[] ids);

    /**
     * 批量更新item
     * @param items
     * @return
     */
    int updatePsiBiddingItemByList(@Param("items") List<PsiBiddingItem> items);

}
