package com.ruoyi.sup.mapper;

import java.util.List;
import com.ruoyi.sup.domain.PsiBidding;
import com.ruoyi.sup.domain.PsiBiddingItem;
import org.apache.ibatis.annotations.Param;

/**
 * 竞价单Mapper接口
 * 
 * @author ruoyi
 * @date 2023-12-17
 */
public interface PsiBiddingMapper 
{
    /**
     * 查询竞价单
     * 
     * @param id 竞价单主键
     * @return 竞价单
     */
    public PsiBidding selectPsiBiddingById(Long id);

    /**
     * 查询竞价单列表
     * 
     * @param psiBidding 竞价单
     * @return 竞价单集合
     */
    public List<PsiBidding> selectPsiBiddingList(PsiBidding psiBidding);

    /**
     * 新增竞价单
     * 
     * @param psiBidding 竞价单
     * @return 结果
     */
    public int insertPsiBidding(PsiBidding psiBidding);

    /**
     * 修改竞价单
     * 
     * @param psiBidding 竞价单
     * @return 结果
     */
    public int updatePsiBidding(PsiBidding psiBidding);

    /**
     * 删除竞价单
     * 
     * @param id 竞价单主键
     * @return 结果
     */
    public int deletePsiBiddingById(Long id);

    /**
     * 批量删除竞价单
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePsiBiddingByIds(Long[] ids);

    void savaBathList(@Param("items") List<PsiBiddingItem> biddingItems, @Param("biddingId") Long biddingId);

    PsiBidding selectBiddingByIdAndTenantId(@Param("id") Long biddingId, @Param("supplierId") Long supplierId);

    List<PsiBidding> selectBiddingByPurchaseId(@Param("purchaseId") Long purchaseId);
}
