package com.ruoyi.sup.service;

import java.util.List;
import com.ruoyi.sup.domain.PsiBidding;
import com.ruoyi.sup.domain.vo.BiddingVO;

/**
 * 竞价单Service接口
 * 
 * @author ruoyi
 * @date 2023-12-17
 */
public interface IPsiBiddingService 
{
    /**
     * 查询竞价单
     * 
     * @param id 竞价单主键
     * @return 竞价单
     */
    public PsiBidding selectPsiBiddingById(Long id);

    /**
     * 查询竞价单列表
     * 
     * @param psiBidding 竞价单
     * @return 竞价单集合
     */
    public List<PsiBidding> selectPsiBiddingList(PsiBidding psiBidding);

    /**
     * 新增竞价单
     * 
     * @param psiBidding 竞价单
     * @return 结果
     */
    public int insertPsiBidding(PsiBidding psiBidding);

    /**
     * 修改竞价单
     * 
     * @param psiBidding 竞价单
     * @return 结果
     */
    public int updatePsiBidding(PsiBidding psiBidding);

    /**
     * 批量删除竞价单
     * 
     * @param ids 需要删除的竞价单主键集合
     * @return 结果
     */
    public int deletePsiBiddingByIds(Long[] ids);

    /**
     * 删除竞价单信息
     * 
     * @param id 竞价单主键
     * @return 结果
     */
    public int deletePsiBiddingById(Long id);

    /**
     * @description 根据采购单id生成竞价单
     *
     * @param purchaseId
     * @param tenantId
     * @return int
     * @author fm
     * @date 2023/12/17 10:12
     */
    int addBidding(Long purchaseId, Long tenantId);

    /**
     *  供应商报价
     * @param vo
     * @return
     */
    int biddingQuote(BiddingVO vo);

    /**
     * @description 根据id 查看当前竞价单
     *
     * @param id
     * @return com.ruoyi.sup.domain.vo.BiddingVO
     * @author fm
     * @date 2023/12/18 11:30
     */
    BiddingVO selectBiddingDetailById(Long id, Long supplierId);

    /**
     * 竞价单提交(供应商提交)    找出最低价格的插入到供货单
     * @param biddingId
     * @return
     */
    int edit(Long biddingId);

}
