package com.ruoyi.sup.service.impl;

import com.ruoyi.common.constant.ApprovalConstants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.psi.domain.*;
import com.ruoyi.psi.domain.vo.StorageVO;
import com.ruoyi.psi.domain.vo.SummaryVO;
import com.ruoyi.psi.mapper.*;
import com.ruoyi.psi.util.CommonUtil;
import com.ruoyi.sup.service.ISupApprovalRecordingService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassName SupApprovalRecordingServiceImpl
 * @Description
 * @Author fm
 * @Date 2024/1/31 11:13
 * @Version V1.0
 */
@Service
public class SupApprovalRecordingServiceImpl implements ISupApprovalRecordingService {

    @Autowired
    private PsiStorageMapper psiStorageMapper;

    @Autowired
    private PsiSrorageItemMapper srorageItemMapper;

    @Autowired
    private CommonUtil commonUtil;

    @Autowired
    private PsiSummaryMapper psiSummaryMapper;

    @Autowired
    private PsiSummaryItemMapper summaryItemMapper;

    @Override
    public AjaxResult getInfo(Long documentId, Integer documentType) {
        switch (documentType){
            case 6:
                PsiStorage storage = psiStorageMapper.selectPsiStorageById(documentId);
                StorageVO vo = new StorageVO();
                BeanUtils.copyProperties(storage,vo);
                List<PsiSrorageItem> items = srorageItemMapper.selectPsiStorageItemByStorageId(vo.getId());

                // 查询入库流程详细
                ApprovalRecording approvalRecording = new ApprovalRecording();
                approvalRecording.setDocumentId(documentId);
                approvalRecording.setDocumentType(ApprovalConstants.RUKU);
                approvalRecording.setzTenantId(storage.getTenantId());
                List<ApprovalRecording> inApprovalRecordingList = commonUtil.getRecordingList(approvalRecording);

                // 查询出库流程详细
                approvalRecording.setDocumentType(ApprovalConstants.CHUKU);
                List<ApprovalRecording> outApprovalRecordingList = commonUtil.getRecordingList(approvalRecording);

                vo.setItems(items);
                vo.setInApprovalRecordingList(inApprovalRecordingList);
                vo.setOutApprovalRecordingList(outApprovalRecordingList);
                return AjaxResult.success(vo);
            case 8:
                SummaryVO summaryVO = new SummaryVO();
                PsiSummary summary = psiSummaryMapper.selectPsiSummaryById(documentId);
                BeanUtils.copyProperties(summary,summaryVO);
                List<PsiSummaryItem> list = summaryItemMapper.selectSummaryItemBySummaryId(documentId);
                summaryVO.setSummaryItems(list);

                // 查询流程详细
                ApprovalRecording approvalRecordingTwo = new ApprovalRecording();
                approvalRecordingTwo.setDocumentId(documentId);
                approvalRecordingTwo.setDocumentType(ApprovalConstants.RUKUHUIZONG);
                approvalRecordingTwo.setzTenantId(summary.getTenantId());

                List<ApprovalRecording> ruApprovalRecordingList = commonUtil.getRecordingList(approvalRecordingTwo);
                summaryVO.setInApprovalRecordingList(ruApprovalRecordingList);

                approvalRecordingTwo.setDocumentType(ApprovalConstants.CHUKUHUIZONG);
                List<ApprovalRecording> chuApprovalRecordingList = commonUtil.getRecordingList(approvalRecordingTwo);
                summaryVO.setOutApprovalRecordingList(chuApprovalRecordingList);

                return AjaxResult.success(summaryVO);
            default:
                System.out.println("错误");
                break;
        }
        return AjaxResult.success();
    }
}