package com.ruoyi.sup.service.impl;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.psi.domain.*;
import com.ruoyi.psi.domain.vo.StorageItemExportVO;
import com.ruoyi.psi.domain.vo.StorageVO;
import com.ruoyi.psi.domain.vo.SupplyVO;
import com.ruoyi.psi.mapper.*;
import com.ruoyi.psi.service.IPsiStorageService;
import com.ruoyi.psi.util.CommonUtil;
import com.ruoyi.sup.domain.SupSrorageItem;
import com.ruoyi.sup.domain.SupStorage;
import com.ruoyi.sup.domain.vo.SupStorageItemVO;
import com.ruoyi.sup.mapper.SupStorageMapper;
import com.ruoyi.sup.service.SupStorageService;
import com.ruoyi.system.domain.SysTenant;
import com.ruoyi.system.mapper.SysTenantMapper;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 入库单Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-12-22
 */
@Service
public class SupStorageServiceImpl implements SupStorageService
{
    @Autowired
    private SysTenantMapper tenantMapper;

    @Autowired
    private SupStorageMapper supStorageMapper;

    @Autowired
    private CommonUtil commonUtil;

    /**
     * 查询满足条件的入库单
     * @param storage
     * @return
     */
    @Override
    public List<SupStorage> selectSupStorageList(SupStorage storage) {
        return supStorageMapper.selectSupStorageList(storage);
    }

    /**
     * 获得入库单详情
     * @param id
     * @return
     */
    @Override
    public List<SupStorageItemVO> getInfoById(Long id) {
        return supStorageMapper.getInfoById(id);
    }

    /**
     * 销货单撤回
     *
     * @param id
     * @return
     */
    @Override
    @Transactional
    public int revokeStorage(Long id) {
        SupStorage storage = supStorageMapper.selectSupStorageById(id);
        storage.setSalesAuditStatus(0);
        // 状态更改
        supStorageMapper.updateStorage(storage);
        // 删除审批记录
        // Long tenantId = SecurityUtils.getLoginUser().getUser().getTenantId();
        ApprovalRecording approvalRecording = new ApprovalRecording();
        approvalRecording.setTenantId(storage.getTenantId());
        approvalRecording.setDocumentId(id);
        approvalRecording.setDocumentType(10);
        commonUtil.edit(approvalRecording);
        return 1;
    }
}
