package com.ruoyi.sup.service.impl;

import com.ruoyi.sup.domain.SupSupply;
import com.ruoyi.sup.domain.SupSupplyItem;
import com.ruoyi.sup.domain.vo.SupSupplyVO;
import com.ruoyi.sup.mapper.SupSupplyMapper;
import com.ruoyi.sup.service.ISupSupplyService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 供货单Service业务层处理
 * 
 * @author ruoyi
 * @date 2023-12-19
 */
@Service
public class SupSupplyServiceImpl implements ISupSupplyService
{
    @Autowired
    private SupSupplyMapper supSupplyMapper;

    /**
     * 查询供货单
     * 
     * @param id 供货单主键
     * @return 供货单
     */
    @Override
    public SupSupplyVO selectSupSupplyById(Long id, Long supplierId)
    {
        SupSupply supply = supSupplyMapper.selectSupSupplyById(id, supplierId);
        SupSupplyVO vo = new SupSupplyVO();
        BeanUtils.copyProperties(supply,vo);
        List<SupSupplyItem> items = supSupplyMapper.selectSupplyItem(id);
        vo.setSupplyItems(items);
        return vo;
    }

    /**
     * 查询供货单列表
     * 
     * @param supSupply 供货单
     * @return 供货单
     */
    @Override
    public List<SupSupply> selectSupSupplyList(SupSupply supSupply)
    {
        return supSupplyMapper.selectSupSupplyList(supSupply);
    }

}
